/* $Header: /CVS/ka10/alu.h,v 1.2 1998/10/06 19:18:25 mcl Exp $ */

/* E10 simulator -- Arithmetic logic unit */

/* Mirian Crzig Lennox <mcl@cosmic.com> started this file. */

/* Add your name and email here when you make meaningful changes */
/* Then mail the changes to me so I know about them! */

/* This program is free software, you can redistribute it and/or
   modify it under the terms of the GNU Public License as published
   by the Free Software Foundation.  It is copyrighted by myself and
   all those who contribute code and annote their names above */

#ifndef _E10_ALU_H_
#define _E10_ALU_H_

void pdp10_add();
void pdp10_sub();
void pdp10_imul();
void pdp10_idiv();

extern unsigned long alu_lo;
extern unsigned long alu_hi;
extern unsigned long alux_lo;
extern unsigned long alux_hi;

#define ALU_SHL(x,y) x<<=1;y<<=1;if(y&~0777777){y&=0777777;x|=1;}
#define ALU_SHR(x,y) y>>=1;if(x&1)y|=0400000;x>>=1
#define ALU_CARRY(x,y) x+=((y&~0777777)>>18);y&=0777777
#define ALU_SHLX(x,y,n) x<<=n;y<<=n;ALU_CARRY(x,y)
#define ALU_SHRX(x,y,n) y>>=n;y|=((x&0777777>>18-n)<<18-n);x>>=n
#define ALU_NEG(x,y) x=~x&0777777;y=(~y&0777777)+1;ALU_CARRY(x,y)
#define ALU_NORM(x,y) x&=0777777;y&=0777777
#define ALU_MASK(x,y) x&=01777777;y&=0777777

#define ALU_ADD(a,b,x,y) a+=x;b+=y;ALU_CARRY(a,b)

#define ALU_ISOVF(x) (x&~0777777)
#define ALU_ISNEG(x) (x&0400000)
#define ALU_ISZERO(x,y) (x==0&&y==0)
#define ALU_ISMIN(x,y) (x==0400000&&y==0)
#define ALU_ISMAX(x,y) (x==0377777&&y=0777777)
#define ALU_ISMINUSONE(x,y) (x==0777777&&y==0777777)

#define ALU_ISEQ(a,b,x,y) (a==x&&b==y)
#define ALU_ISGT(a,b,x,y) (a>x||(a==x&&b>y))
#define ALU_ISLT(a,b,x,y) (a<x||(a==x&&b<y))
#define ALU_ISGE(a,b,x,y) (!(ALU_ISLT(a,b,x,y)))
#define ALU_ISLE(a,b,x,y) (!(ALU_ISGT(a,b,x,y)))
#define ALU_ISNE(a,b,x,y) (!(ALU_ISEQ(a,b,x,y)))

#endif /* _E10_ALU_H_ */
