/* E10-KL10 RECODE 4 VERSION 125 */
/* VERSION HISTORY:  (Note that the version numbers are OCTAL!)
   57:  Creation.  Demise of REWRITE 3.
   60:  Command parser.
   61:  Handling of various control codes.
   62:  Beginnings of processor code.
   63:  e_addr calc implemented.
   64:  EXCH,core save/load.
   65:  MOVE, MOVEI, MOVEM, MOVES
   66:  MOVS, MOVSI, MOVSM, MOVSS
   67:  MOVN, MOVNI, MOVNM, MOVNS
   70:  MOVM, MOVMI, MOVMM, MOVMS
   71:  DMOVE, DMOVEM
   72:  BLT
   73:  ADD,ADDI,ADDM,ADDB
   74:  SUB,SUBI,SUBM,SUBB
   75:  IMUL,IMULI,IMULM,IMULB
   76:  SETZ,SETZI,SETZM,SETZB
   77:  SETO,SETOI,SETOM,SETOB
   100: SETA,SETAI,SETAM,SETAB
   101: SETCA,SETCAI,SETCAM,SETCAB
   102: SETM,SETMI,SETMM,SETMB,SETCM,SETCMI,SETCMM,SETCMB
   103: AND,ANDI,ANDM,ANDB
   104: ANDCA, ANDCAI, ANDCAM, ANDCAB
   105: ANDCM, ANDCMI, ANDCMM, ANDCMB
   106: ANDCB, ANDCBI, ANDCBM, ANDCBB
   107: OR,ORI,ORM,ORB
   110: ORCA,ORCAI,ORCAM,ORCAB,ORCM,ORCMI,ORCMM,ORCMB,ORCB,ORCBI,ORCBM,ORCBB,
   XOR,XORI,XORM,XORB,EQV,EQVI,EQVM,EQVB,AOBJP,AOBJN
   111: LSH,LSHC,ROT,ROTC,CAI,CAIL,CAIE,CAILE,CAIA,CAIGE,CAIN,CAIG,
   CAM,CAML,CAME,CAMLE,CAMA,CAMGE,CAMN,CAMG
   112: JUMP,JUMPL,JUMPE,JUMPLE,JUMPA,JUMPGE,JUMPN,JUMPG
   SKIP,SKIPL,SKIPE,SKIPLE,SKIPA,SKIPGE,SKIPN,SKIPG
   AOJ,AOJL,AOJE,AOJLE,AOJA,AOJGE,AOJN,AOJG
   AOS,AOSL,AOSE,AOSLE,AOSA,AOSGE,AOSN,AOSG
   SOJ,SOJL,SOJE,SOJLE,SOJA,SOJGE,SOJN,SOJG
   SOS,SOSL,SOSE,SOSLE,SOSA,SOSGE,SOSN,SOSG
   113: Found out how to abuse macros!
   NXT_INST, DO_SKIP, and DO_JUMP (to e_addr) added.
   Fixed screw in command parser.
   TRN*,TRZ*,TRC*,TRO*,TLN*,TLZ*,TLC*,TLO*,TDN*,TDZ*,
   TDC*,TDO*,TSN*,TSZ*,TSC*,TSO*
   114: HLL*,HLLZ*,HLLO*,HLLE*,HRL*,HRLZ*,HRLO*,HRLE*
   HRR*,HRRZ*,HRRO*,HRRE*,HLR*,HLRZ*,HLRO*,HLRE*
   XCT,JFFO,JFCL
   115: JRST,JSR,JSP,JSA,JRA,PUSH,POP,PUSHJ,POPJ,ADJSP
   116: LDB, DPB, IBP, ILDB, IDPB, IO instruction traps
   117: EXTENDED ADDRESSING, XMOVEI, XBLT, XHLLI, more JRST toys.
   120: Initial DTE20 code and console interfacing
   121: parts PI system, parts of TOPS-10 Paging, usermode fixes, IDIV
   122: IDIV fix
   123: Byte pointer stuff fixed
   124: Fixing various.
   125:    Fixes to: MOVS, BLT, XBLT

 */

/* INITAL NOTES:
   Credits:
   Daniel Seagraves <daniel@umtec.com> started this.
   Mirian Crzig Lennox <mcl@cosmic.com> helped with the math toys.
   Eric Smith provided the manuals I needed.
   Devon (whose email and last name I've lost, sorry!) pointed out that the 
   original lost badly and contributed some code.
   And Ami Mizuno <mercury@nqs.ctokyo.jp> provided the inspiration.

   Additional credits:
   Digital Equipment Corporation [RIP] provided the wonderful PDP-10, and 
   TOPS to go with it.
   XKL let me play with their TD-1, without which this wouldn't go.
   Ditto for Paul Allen of Microsoft, who also let me play with his TD...
   The hackers at MIT made the OS that made running them worthwhile. :)
   [ No holy wars intended, just a poke... ]
   For that matter, thanks to all the hackers of old for their contributions.
   Everyone from alt.sys.pdp-10 was a good help.
   And apologies to anyone I missed!

   LEGALESE:
   This program is free software.  You can resdistribute it and/or modify it 
   under the terms of the GNU Public License as published by the Free 
   Software Foundation.  It is copyrighted by myself and all those who 
   annotated their names above as working on the project.

   [TRANSLATION:  This is free.  You can do whatever with it, but you can't 
   charge money for it.  You also can't swipe it and claim you wrote it.
   Besides, that would be wrong.  If you tried that, I'd have to get Goddess 
   to come whup your arse.]

   DISCLAIMER:
   If this program, or any form of it, whether compiled, source, or 
   otherwise, causes your computer to break, slow down, halt, catch fire, or 
   spontaneously jump back in time, we *ARE NOT* responsible for it!  You 
   cannot hold any party whatsoever responsible for any damages or percieved 
   damages caused by the use and or distribution of this software.

   [TRANSLATION: If this breaks, too bad.  Maybe I'll fix it.  If you decide 
   that this program has somehow cost you money, too bad.  You can't sue anyone.
   Besides, that would be stupid.]

 */

/*

   DESIGN NOTES:

   Writing the KL as a bunch of independent programs sucked hard - 3 second 
   instruction cycle times on a P233?  So, this needs to be consolidated 
   into one program.

   Back to the original method, with some fixes for various screws.

   Note:        Hiding obscure refrences in the source code is encouraged.
   Hopefully you can find better and more obscure ones than I can... :)

 */

/* Include files. */
#include <termios.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <signal.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/time.h>
#include <sys/types.h>
#include <string.h>
#include "op.c"
#include "op.h"
#include "flags.h"
#include "math.h"

/* DEFINEs */
#define SERIALNUMBER	3642;	/* PROC. SERIAL # */
#define UCODE_VERSION	0125;	/* MICROCODE VERSION */
#define MEMORY_SIZE	4194304	/* MEMORY SIZE */

/* Variable declarations */
unsigned long long pc;		/* Program Counter */
unsigned long cpu_section;	/* CPU current section */
unsigned long long vma;		/* Virtual memory addr */
unsigned long long pma;		/* Physical mem addr */
unsigned long long ar, arx;	/* Arith reg, and extension */
unsigned long long br, brx;	/* Buffer reg, and extension */
long sctr;			/* Shift/Rotate count */
unsigned long io_dev_nr;	/* For IO instructions */
unsigned long long fm[8][017];	/* Fast Memory (ACs) */
unsigned long ir, ma;		/* Inst Reg, Mem Addr */
unsigned long ac;		/* Which ac? */
unsigned opc;			/* Opcode */
unsigned long id_bit, id_ac, inst_addr;		/* Instruction decode toys */
unsigned long long jrstf_ptr;	/* JRSTF toy */
unsigned long long e_addr, global_mode;		/* Effective address */
int run;			/* CPU RUN flag */
unsigned long long *memory;	/* Memory */
unsigned long micropc;		/* Microcode PC */
int ucode_start, ucode_stop, ucode_break;	/* For console commands */
unsigned long long ll_buffer;	/* Scratch */
FILE *corefile;			/* For read in and out */
unsigned long bptr_size, bptr_pos;	/* Byte pointer bits */
unsigned long bptr_addr, bptr_type;
unsigned long bptr_loc, bptr_ac, bptr_ind;

/* CLI toys */
int termfile;			/* fd for terminal */
struct termios termios_p, termios_old;	/* TERMIOS toys */
char termbuf, linebuf[1024];	/* Storing commands */
int x, y;			/* Used for decoding */
int linepos;			/* Position marker */
char promptstring[] = "KL> ";	/* The prompt */
char promptstring2[] = "KL: ";	/* The prompt when running */
char backspace[] = "\b";	/* Send on DEL */
char termnlbel[] = "\a";	/* Terminal bell */
char cmd[30], addrstr[30], datastr_lf[30];	/* CLI strings */
char datastr_rt[30];
unsigned long con_addr, con_data_lf;	/* CLI vars */
unsigned long con_data_rt;
int consolemode;		/* Console mode (cmd or dte) */
int inst_trace;			/* Trace flag */
unsigned long long cons_scratch;	/* SCRATCH */
unsigned long sblk_count, sblk_addr;	/* SBLK LOADER */

/* Functions */
	/* Memory */
int dep_word (unsigned long addr, unsigned long long data);
unsigned long long exa_word (unsigned long addr);
unsigned long long do_memory_read (unsigned long addr, int fetch_flag);
int do_memory_write (unsigned long addr, unsigned long long data);
	/* Data Manipulation */
unsigned long long form_word (unsigned long data_lf, unsigned long data_rt);
unsigned long get_lf_half (unsigned long long data);
unsigned long get_rt_half (unsigned long long data);
unsigned long parse_byte_pointer (unsigned long long data);
unsigned long long build_byte_pointer ();
	/* Other */
int kl10_cycle ();
unsigned long calc_e_addr (unsigned long long data);
unsigned long long apr_blko ();
void cons_set_tty_noecho ();
void cons_set_tty_echo ();


/* Macros */
#define	NXT_INST	micropc=0; break
#define DO_SKIP		pc=form_word(get_lf_half(pc),get_rt_half(pc)+1)
#define DO_JUMP		pc=form_word(get_lf_half(pc),e_addr)

/* DEVICE DRIVER #INCLUDES */
#include "dte20.h"		/* DTE-20 10<>11 INTERFACE */
#include "pisys.h"		/* PRIORITY INTERRUPT SYSTEM */
#include "pager.h"		/* TOPS-10 PAGING */

/* ****** And yet I look forward to the future...
   I wish for the White One to come
   and deliver us all to Everlasting Moonlight.
   But the Story isn't true - it can't possibly happen.
   Is it wrong for me to have hope against the truth?
   - Suzuran Majere.                         ******* */

/* Main procedure */
int 
main ()
{
/* Initialize this puppy. */

/* Banner */
  printf ("NEW-KL10 SIM CONSOLE 125\n");
  memory = malloc (MEMORY_SIZE);	/* Get this */
  micropc = 0;			/* Set this up. */

  printf ("Setting up the terminal\n");
  termfile = open ("/dev/tty", O_NDELAY | O_RDWR | O_SYNC, 0);
  tcgetattr (termfile, &termios_old);
  tcgetattr (termfile, &termios_p);
  termios_p.c_lflag &= ~(ICANON | ISIG);
  tcsetattr (termfile, TCSANOW, &termios_p);
  consolemode = 0;
  dte_ibuf[0] = 0;
  dte_obuf[0] = 0;
  dte_iptr = 0;
  dte_optr = 0;

prompt:
  if (consolemode == 1)
    {
      /* DTE20 mode - Any char goes to dte_ibuf at dte_iptr */
      /* except for ^\ - This toggles the consolemode back to 0 */
      if (read (termfile, &termbuf, 1) == 1)
	{
	  if (termbuf == 034)
	    {			/* Caught ^\ */
	      printf ("%%CONSOLE MODE\n");
	      /* NEED TO TURN ON ECHO HERE! */
	      cons_set_tty_echo ();
	      consolemode = 0;
	      goto prompt;
	    }
	  else
	    {
	      /* Put in DTE20 */
	      dte_iptr++;
	      dte_ibuf[dte_iptr] = termbuf;
	    }
	}
      goto skip_for_dte;
    }

  if (run)
    {
      write (termfile, &promptstring2, 4);
    }
  if (!run)
    {
      write (termfile, &promptstring, 4);
    }
  fsync (termfile);
  linepos = 0;

/* Parse commands here */

loop:
  /* Check for a char */
  if (read (termfile, &termbuf, 1) == 1)
    {
      switch (termbuf)
	{
	case 3:		/* ^C */
	  printf ("?USE QU INSTEAD PLEASE\n");
	  break;
	case '\n':		/* Newline */
	  linebuf[linepos] = 0;
	  goto parser;
	  break;
	  /* Toggle DTE20 mode on ^\ */
	case 034:
	  printf ("%%TERMINAL MODE\n");
	  /* NEED TO TURN OFF ECHO HERE! */
	  cons_set_tty_noecho ();
	  consolemode = 1;
	  /* Now, type garbage that needs it... */
	  while (dte_optr > 0)
	    {
	      write (termfile, &dte_obuf[dte_optr], 1);
	      dte_optr--;
	    }
	  goto prompt;
	  break;
	  /* Delete? */
	case 127:
	  linepos--;
	  linebuf[linepos] = 0;
	  write (termfile, &backspace, 1);
	  /* write(termfile,&backspace,1);
	     write(termfile,&backspace,1); */
	  break;

	  /* Backspace? */
	case 8:
	  linepos--;
	  linebuf[linepos] = 0;
	  break;
	default:
	  linebuf[linepos] = termbuf;
	  linepos++;
	  break;
	}
    }
skip_for_dte:
/* Service the decsystem */
  kl10_cycle ();
  if (consolemode == 2)
    {
      consolemode = 0;
      goto prompt;
    }
  if (consolemode == 1)
    {
      goto prompt;
    }

  goto loop;
parser:

/* This generates 4 strings:  Address, data right, and data left */
  x = 0;
  y = 0;
  while (linebuf[x] != ' ')
    {
      if (x >= strlen (linebuf))
	{
	  cmd[y] = 0;
	  break;
	}
      cmd[y] = linebuf[x];
      x++;
      y++;
    }
  cmd[y] = 0;
  y = 0;
  x++;

  while (linebuf[x] != ' ')
    {
      if (x >= strlen (linebuf))
	{
	  addrstr[y] = 0;
	  break;
	}
      addrstr[y] = linebuf[x];
      x++;
      y++;
    }
  addrstr[y] = 0;
  y = 0;
  x++;

  while (linebuf[x] != ' ')
    {
      if (x >= strlen (linebuf))
	{
	  datastr_lf[y] = 0;
	  break;
	}
      datastr_lf[y] = linebuf[x];
      x++;
      y++;
    }
  datastr_lf[y] = 0;
  y = 0;
  x++;

  while (linebuf[x] != ' ')
    {
      if (x >= strlen (linebuf))
	{
	  datastr_rt[y] = 0;
	  break;
	}
      datastr_rt[y] = linebuf[x];
      x++;
      y++;
    }
  datastr_rt[y] = 0;
  y = 0;
  x++;

/* Conversion to octal */

/* printf("PAR: %s %s %s %s\n",cmd,addrstr,datastr_lf,datastr_rt); */

  con_addr = strtoul (addrstr, NULL, 8);
  con_data_lf = strtoul (datastr_lf, NULL, 8);
  con_data_rt = strtoul (datastr_rt, NULL, 8);

/* Deal with commands */

  if (!strncmp (cmd, "QU", 2))
    {
      printf ("%%AND NOW FOR SOMETHING COMPLETELY DIFFERENT\n");
      /* "Bye" - Jennifer Sakatchi, Bishoujo Senshi Sailor Orion */
      goto clidone;
    }

  if (!strncmp (cmd, "DM", 2))
    {
      printf ("%%WROTE %lo,,%lo\n", con_data_lf, con_data_rt);
      if (con_addr < 020)
	{
	  fm[pg_fm_block][con_addr] = form_word (con_data_lf, con_data_rt);
	}
      else
	{
	  dep_word (con_addr, form_word (con_data_lf, con_data_rt));
	}

      goto prompt;
    }

  if (!strncmp (cmd, "IT", 2))
    {
      if (inst_trace == 1)
	{
	  inst_trace = 0;
	  printf ("%%TRACE OFF\n");
	}
      else
	{
	  inst_trace = 1;
	  printf ("%%TRACE ON\n");
	}
      goto prompt;
    }

  if (!strncmp (cmd, "EM", 2))
    {
      if (con_addr < 020)
	{
	  printf ("%%DATA: %lo,,%lo\n", get_lf_half (fm[pg_fm_block][con_addr]), get_rt_half (fm[pg_fm_block][con_addr]));
	}
      else
	{
	  printf ("%%DATA %lo,,%lo\n", get_lf_half (exa_word (con_addr)), get_rt_half (exa_word (con_addr)));
	}

      goto prompt;
    }

  if (!strncmp (cmd, "RS", 2))
    {
      /* Read SBLK */
      if (!(corefile = fopen (addrstr, "r")))
	{
	  perror ("Error opening file");
	  goto prompt;
	}
      printf ("%%SBLK LOAD: Looking for JRST 1...\n");
    lsblk1:
      fread (&cons_scratch, 8, 1, corefile);
      if (!(cons_scratch == 0254000000001LL))
	{
	  goto lsblk1;
	}
      printf ("%%SBLK LOAD: Found JRST 1\n");
      /* Past the SBLK loader */
    lsblk2:
      fread (&cons_scratch, 8, 1, corefile);
      if (get_lf_half (cons_scratch) & 0400000)
	{
	  printf ("%%SBLK LOAD: Small block, count %lo, start %lo.\n", get_lf_half (cons_scratch), get_rt_half (cons_scratch));
	  sblk_count = get_lf_half (cons_scratch);
	  sblk_addr = get_rt_half (cons_scratch);
	  while (sblk_count < 01000000LL)
	    {
	      /* Read block data */
	      fread (&cons_scratch, 8, 1, corefile);
	      if (feof (corefile))
		{
		  printf ("UNEXPECTED EOF\n");
		  fclose (corefile);
		  goto rs_done;
		}
	      dep_word (sblk_addr, cons_scratch);
	      sblk_count++;
	      sblk_addr++;
	    }
	  /* Blow the checksum */
	  printf ("%%SBLK LOAD: BLOCK DONE\n");
	  fread (&cons_scratch, 8, 1, corefile);
	  goto lsblk2;
	}
      /* Not negative */
      printf ("%%SBLK LOAD: POSITIVE FOUND - START ADDR APPEARS TO BE %lo\n", get_rt_half (cons_scratch));
      fclose (corefile);
    rs_done:
      goto prompt;
    }

  if (!strncmp (cmd, "LC", 2))
    {
      if (!(corefile = fopen (addrstr, "r")))
	{
	  perror ("Error opening file");
	  goto prompt;
	}
      con_addr = 0;
      while (con_addr < 262144)
	{
	  fread (&ll_buffer, 8, 1, corefile);
	  dep_word (con_addr, ll_buffer);
	  printf ("%%DATA %lo,,%lo\n", get_lf_half (exa_word (con_addr)), get_rt_half (exa_word (con_addr)));
	  if (feof (corefile))
	    {
	      break;
	    }
	  con_addr++;
	}
      fclose (corefile);
      goto prompt;
    }

  if (!strncmp (cmd, "SC", 2))
    {
      if (!(corefile = fopen (addrstr, "w")))
	{
	  perror ("Error opening file");
	  goto prompt;
	}
      con_addr = 0;
      while (con_addr < 262144)
	{
	  ll_buffer = exa_word (con_addr);
	  fwrite (&ll_buffer, 8, 1, corefile);
	  if (feof (corefile))
	    {
	      break;
	    }
	  con_addr++;
	}
      fclose (corefile);
      goto prompt;
    }

  if (!strncmp (cmd, "ST", 2))
    {
      /* Start CPU */
      if (strlen (addrstr) > 0)
	{
	  printf ("%%STARTING AT %lo\n", con_addr);
	  pc = (pc & 0777777000000LL) | (con_addr & 0777777);
	}
      ucode_start = 1;
      printf ("%%REQUESTING CPU START\n");
      printf ("%%ENTERING DTE MODE\n");
      /* NEED TO TURN OFF ECHO HERE! */
      cons_set_tty_noecho ();
      consolemode = 1;
      /* Now, type garbage that needs it... */
      while (dte_optr > 0)
	{
	  write (termfile, &dte_obuf[dte_optr], 1);
	  dte_optr--;
	}
      goto prompt;
    }

  if (!strncmp (cmd, "CO", 2))
    {
      /* Start CPU */
      ucode_start = 3;
      printf ("%%REQUESTING CPU CONTINUE - ENTERING DTE MODE\n");
      /* NEED TO TURN OFF ECHO HERE! */
      cons_set_tty_noecho ();
      consolemode = 1;
      /* Now, type garbage that needs it... */
      while (dte_optr > 0)
	{
	  write (termfile, &dte_obuf[dte_optr], 1);
	  dte_optr--;
	}
      goto prompt;
    }

  if (!strncmp (cmd, "US", 2))
    {
      /* MicroStep CPU */
      if (strlen (addrstr) > 0)
	{
	  printf ("%%STARTING AT %lo\n", con_addr);
	  pc = (pc & 0777777000000LL) | (con_addr & 0777777);
	}
      ucode_start = 2;
      ucode_stop = 1;
      printf ("%%REQUESTING CPU STEP - ENTERING DTE MODE\n");
      /* NEED TO TURN OFF ECHO HERE! */
      cons_set_tty_noecho ();
      consolemode = 1;
      /* Now, type garbage that needs it... */
      while (dte_optr > 0)
	{
	  write (termfile, &dte_obuf[dte_optr], 1);
	  dte_optr--;
	}
      goto prompt;
    }

  if (!strncmp (cmd, "SB", 2))
    {
      /* Set CPU breakpoint */
      ucode_break = con_addr;
      printf ("%%SETTING BREAKPOINT\n");
      goto prompt;
    }

  if (!strncmp (cmd, "SS", 2))
    {
      /* Step CPU */
      if (strlen (addrstr) > 0)
	{
	  printf ("%%STARTING AT %lo\n", con_addr);
	  pc = (pc & 0777777000000LL) | (con_addr & 0777777);
	}
      ucode_start = 2;
      ucode_stop = 2;
      printf ("%%REQUESTING CPU STEP - ENTERING DTE MODE\n");
      /* NEED TO TURN OFF ECHO HERE! */
      cons_set_tty_noecho ();
      consolemode = 1;
      /* Now, type garbage that needs it... */
      while (dte_optr > 0)
	{
	  write (termfile, &dte_obuf[dte_optr], 1);
	  dte_optr--;
	}
      goto prompt;
    }
  if (!strncmp (cmd, "PS", 2))
    {
      printf ("CPU: %s %lo %lo | PC %lo,,%lo | uPC %lo\n", op_str[opc], ac, (unsigned long) e_addr, get_lf_half (pc), get_rt_half (pc), micropc);
      goto prompt;
    }

  if (!strncmp (cmd, "HA", 2))
    {
      /* Halt CPU */
      printf ("%%REQUESTING CPU HALT\n");
      ucode_stop = 1;
      goto prompt;
    }

  if (!strncmp (cmd, "HE", 2))
    {
      /* HELP */
      printf ("E10-KL10 COMMANDS LIST\n");
      printf ("QU				QUIT\n");
      printf ("DM <addr> <data lf> <data rt>	DEPOSIT MEMORY\n");
      printf ("EM <addr>			EXAMINE MEMORY\n");
      printf ("ST <addr>			START CPU\n");
      printf ("SS <addr>			STEP CPU\n");
      printf ("US                              MICROSTEP CPU\n");
      printf ("HA				HALT CPU\n");
      printf ("HE				THIS TEXT\n");
      printf ("LC <file>                       LOAD CORE\n");
      printf ("SC <file>			SAVE CORE\n");
      printf ("RS <file>			READ SBLK FILE\n");
      printf ("PS				PROCESSOR STATUS\n");
      printf ("CO				CONTINUE PROCESSOR\n");
      goto prompt;
    }

  printf ("?UNKNOWN COMMAND\n");

  goto prompt;
clidone:
/* Clean up */
  printf ("Exiting - restoring terminal\n");
  tcsetattr (termfile, TCSANOW, &termios_old);
  close (termfile);
  exit (0);
}

int 
dep_word (unsigned long addr, unsigned long long data)
{
  if (addr > MEMORY_SIZE)
    {
      printf ("%%CPU: Umm, you can't write past the end of memory!\n");
      printf ("%%CPU: %s %lo %lo | PC %lo,,%lo | uPC %lo\n", op_str[opc], ac, (unsigned long) e_addr, get_lf_half (pc), get_rt_half (pc), micropc);
      return (0);
    }

/* Check for AC, for LC routine. */

  if (addr < 020)
    {
      fm[pg_fm_block][addr] = data;
      return (0);
    }

  memory[addr] = data;
  return (0);
}

unsigned long long 
exa_word (unsigned long addr)
{
  if (addr > MEMORY_SIZE)
    {
      printf ("%%CPU: Umm, you can't read past the end of memory!\n");
      printf ("%%CPU: %s %lo %lo | PC %lo,,%lo | uPC %lo\n", op_str[opc], ac, (unsigned long) e_addr, get_lf_half (pc), get_rt_half (pc), micropc);
      return (0);
    }

  if (addr < 020)
    {
      return (fm[pg_fm_block][addr]);
    }


  return (memory[addr]);
}

unsigned long long 
form_word (unsigned long data_lf, unsigned long data_rt)
{

  unsigned long long scratch;
  scratch = data_lf;
  scratch = scratch << 18;
  scratch = scratch | data_rt;
  return (scratch);

}

unsigned long 
get_lf_half (unsigned long long data)
{

  unsigned long scratch;
  scratch = ((data >> 18) & 0777777);
  return (scratch);

}

unsigned long 
get_rt_half (unsigned long long data)
{
  return (data & 0777777);
}

/* ***** KH-10 CPU ***** */

int 
kl10_cycle ()
{
/* This routine should not run for more than a few steps. */

/* One.  Is the CPU running? */
  if (!run)
    {
      /* It's not.  Should I start it? */
      if (ucode_start == 1)
	{
	  printf ("CPU: Console requested CPU start\n");
	  ucode_start = 0;
	  run = 1;
	  micropc = 0;
	  goto running;
	}
      if (ucode_start == 2)
	{
	  ucode_start = 0;
	  run = 1;
	  goto stepping;
	}
      if (ucode_start == 3)
	{
	  run = 1;
	  ucode_start = 0;
	  goto running;
	}
      return (0);
    }
running:
/* It's running. Should I stop it?. */
  if (ucode_stop == 1)
    {
      printf ("CPU: Console requested stop at %li\n", micropc);
      ucode_stop = 0;
      goto do_halt;
    }
  if (ucode_stop == 2)
    {
      /* Instruction step, so stop only if micropc is zero. */
      if (micropc == 0)
	{
	  printf ("CPU: STEP EXPIRED\n");
	  ucode_stop = 0;
	  goto do_halt;
	}
    }
  if (ucode_stop == 3)
    {
      /* Halt because of internal error */
      printf("CPU: Micromachine crash, uPC %lo\n", micropc);
      ucode_stop=0;
      goto do_halt;
    }
  if (ucode_break)
    {
      if ((ucode_break == (pc & 0777777)) && (micropc == 0))
	{
	  /* Breakpoint */
	  printf ("%%CPU: BREAKPOINT MATCH\n");
	  goto do_halt;
	}
    }

stepping:

/* PI system check */
  pi_check ();

  switch (micropc)
    {
    case 0:
      /* This is the NEXT INSTRUCTION dispatch.  PC must point
         to the instruction to deal with. */
      /* printf("CPU: FETCHING AT %lo\n",(unsigned long)(pc&0777777)+(cpu_section<<18)); */
      arx = do_memory_read ((unsigned long) ((pc & 0777777) + (cpu_section << 18)), 1);

/* Inst to ARX */
      brx = arx;
      /* Build instruction-based toys */
      ac = (arx & (0000740000000LL)) >> 23;
      id_bit = (arx & (0000020000000LL)) >> 22;
      id_ac = (arx & (0000017000000LL)) >> 18;
      inst_addr = arx & 0777777;

      /* Update the PC */
      br = pc;
      br = br & 0777777;	/* Clear top half */
      pc = pc & 0777777000000LL;	/* Clear bottom half */
      br++;			/* Raise this */
      pc = pc | (br & 0777777);	/* Put address back */

      micropc = 1;		/* Next step */
      break;

    case 1:
      /* XCT ENTRY HERE */
      /* Instruction is in ARX.  Deal with it. */
      /* First, if this is a PI cycle, go for last half of std or
         vector interrupt */
      /* Deal with meter requests */
      /* If PI system has a request, do a PI cycle */
      /* NOTE - THIS IS NOW ELSEWHERE */
      /* If there's a trap flag set, deal with it. */
      /* Otherwise, let's do this bit. */

      micropc = 2;
      break;

    case 2:
      /* Calculate the effective address */
      /* When that's done, push the PC up one, and jump to the main 
         body of the microcode. */

      e_addr = calc_e_addr (arx);

      /* We're done! */
      micropc = 3;
      break;

    case 3:
      /* The e_addr calc is done.  e_addr is valid now.
         Rebuild the instruction-dependent variables, and
         branch out to the instruction ucode. */

      /* Build instruction-based toys */
      ac = (arx & (0000740000000LL)) >> 23;
      id_bit = (arx & (0000020000000LL)) >> 22;
      id_ac = (arx & (0000017000000LL)) >> 18;
      inst_addr = arx & 0777777;
      opc = ((arx & 0777000000000LL) >> 27);
      brx = arx;

      /* Let the console know what's going on. */
      if (inst_trace)
	{
	  printf ("CPU: %s %lo %lo | PC %lo,,%lo | IW %lo,,%lo\n", op_str[opc], ac, (unsigned long) e_addr, get_lf_half (pc), get_rt_half (pc), get_lf_half (brx), get_rt_half (brx));
	}
      /* Now, branch out. */
      micropc = 100 + opc;
      break;
      /* And now, the interesting part. */

/* FULL WORD DATA TRANSMISSION */

    case 100 + OP_EXCH:
      /* E <> AC */

      br = do_memory_read (ac, 0);
      do_memory_write (ac, do_memory_read (e_addr, 0));
      do_memory_write (e_addr, br);
      /* Done. */
      micropc = 0;		/* NXT INST */
      break;

    case 100 + OP_MOVE:
      /* E > AC */
      do_memory_write (ac, do_memory_read (e_addr, 0));
      micropc = 0;
      break;

    case 100 + OP_MOVEI:
      /* 0,,E > AC */
      do_memory_write (ac, form_word (0, e_addr));
      micropc = 0;
      break;

    case 100 + OP_MOVEM:
      /* AC > E */
      do_memory_write (e_addr, do_memory_read (ac, 0));
      micropc = 0;
      break;

    case 100 + OP_MOVES:
      /* E > E, but also AC if AC is nonzero */
      do_memory_write (e_addr, do_memory_read (e_addr, 0));
      if (ac)
	{
	  do_memory_write (ac, do_memory_read (e_addr, 0));
	}
      micropc = 0;
      break;

    case 100 + OP_MOVS:
      /* S(E) > AC */
      br = do_memory_read (e_addr, 0);
      do_memory_write (ac, form_word (get_rt_half (br), get_lf_half (br)));
      micropc = 0;
      break;

    case 100 + OP_MOVSI:
      /* E,,0 > AC */
      do_memory_write (ac, form_word (e_addr, 0));
      micropc = 0;
      break;

    case 100 + OP_MOVSM:
      /* S(AC) > E */
      br = do_memory_read (ac, 0);
      do_memory_write (e_addr, form_word (get_rt_half (br), get_lf_half (br)));
      micropc = 0;
      break;

    case 100 + OP_MOVSS:
      /* S(E) > E, S(E) > AC if AC nonzero */
      br = do_memory_read (e_addr, 0);
      do_memory_write (e_addr, form_word (get_rt_half (br), get_lf_half (br)));
      if (ac)
	{
	  do_memory_write (ac, form_word (get_rt_half (br), get_lf_half (br)));
	}
      micropc = 0;
      break;

    case 100 + OP_MOVN:
      /* -E > AC */
      br = do_sub (0, do_memory_read (e_addr, 0));	/* - to BR */
      do_memory_write (ac, br);	/* Store it */
      micropc = 0;
      break;			/* NEXT INSTR */

    case 100 + OP_MOVNI:
      /* -0,,E > AC */
      br = do_sub (0, form_word (0, e_addr));	/* Do this */
      do_memory_write (ac, br);	/* Store */
      micropc = 0;
      break;

    case 100 + OP_MOVNM:
      /* -AC > E */
      br = do_sub (0, do_memory_read (ac, 0));	/* Do this */
      do_memory_write (e_addr, br);	/* Store result */
      micropc = 0;
      break;			/* Next */

    case 100 + OP_MOVNS:
      /* -E > E, -E > AC if AC nonzero */
      br = do_sub (0, do_memory_read (e_addr, 0));	/* Do this */
      do_memory_write (e_addr, br);	/* This too */
      if (ac)
	{
	  do_memory_write (ac, br);	/* Here too if we must */
	}
      micropc = 0;
      break;

    case 100 + OP_MOVM:
      /* AC < Absolute value of E */
      br = do_memory_read (e_addr, 0);
      if (br & 0400000000000LL)
	{
	  br = do_imul (0777777777776LL, br);
	}
      do_memory_write (ac, br);	/* Store */
      micropc = 0;
      break;

    case 100 + OP_MOVMI:
      /* AC < Absolute value of 0,,E_ADDR */
      br = form_word (0, e_addr);
      if (br & 0400000000000LL)
	{
	  br = do_imul (0777777777776LL, br);
	}
      do_memory_write (ac, br);	/* Store */
      micropc = 0;
      break;

    case 100 + OP_MOVMM:
      /* E < Absolute value of AC */
      br = do_memory_read (ac, 0);
      if (br & 0400000000000LL)
	{
	  br = do_imul (0777777777776LL, br);
	}
      do_memory_write (e_addr, br);	/* Store */
      micropc = 0;
      break;

    case 100 + OP_MOVMS:
      /* E < Absolute value of E, AC also if it's nonzero */
      /* AC < Absolute value of E */
      br = do_memory_read (e_addr, 0);
      if (br & 0400000000000LL)
	{
	  br = do_imul (0777777777776LL, br);
	}
      do_memory_write (e_addr, br);	/* Store */
      if (ac)
	{
	  do_memory_write (ac, br);	/* Here too */
	}
      micropc = 0;
      break;

    case 100 + OP_DMOVE:
      /* E,E+1 > AC,AC+1 */
      do_memory_write (ac, do_memory_read (e_addr, 0));
      do_memory_write (ac + 1, do_memory_read (e_addr + 1, 0));
      micropc = 0;
      break;

    case 100 + OP_DMOVEM:
      /* AC,AC+1 > E,E+1 */
      do_memory_write (e_addr, do_memory_read (ac, 0));
      do_memory_write (e_addr + 1, do_memory_read (ac + 1, 0));
      micropc = 0;
      break;

/* DMOVN AND DMOVNM need floating point math */

    case 100 + OP_BLT:
      /* Starting at AC left, move to address at AC rt until ACrt = E */
      /* Block Transfer, interruptable version. */
      br = do_memory_read (ac, 0);

      /* Form addresses */
      ar = ((cpu_section << 18) | get_lf_half (br));
      arx = ((cpu_section << 18) | get_rt_half (br));

      if ((get_rt_half (br) & 0777777) == (e_addr & 0777777) + 1)
	{
	  /* We moved a word to E.  Finish. */
	  micropc = 0;
	  break;
	}
      /* No.  Move the word */
      do_memory_write (arx, do_memory_read (ar, 0));
      /* Raise both halves */
      br = form_word (get_lf_half (br) + 1, get_rt_half (br) + 1);	/* NO CARRY */
      do_memory_write (ac, br);
      /* Break here.  micropc still points at me, so the next microcycle
         will return to this subroutine, unless there's a PI or something. */
      break;

/* XBLT goes here when the multisection toys get put in. */

    case 100 + OP_XBLT:
      /* eXtended BLT */
      /* Our control block is at AC, AC+1, and AC+2.
         AC:  # of words in block
         AC+1:        Global location of source block
         AC+2:        Global location of destination block
       */
      ar = do_memory_read (ac, 0);
      br = do_memory_read (ac + 1, 0);
      brx = do_memory_read (ac + 2, 0);
      /* AR now has #, BR has source addr, BRX has dst addr */
      do_memory_write (brx, do_memory_read (br, 0));	/* BLT */
      br++;
      brx++;
      ar--;			/* Screw with these */
      /* SAVE MY WORK */
      do_memory_write (ac, ar);
      do_memory_write (ac + 1, br);
      do_memory_write (ac + 2, brx);

      if (ar == 0)
	{
	  NXT_INST;
	}			/* Leave if done */
      break;			/* Allow PIs */

    case 100 + OP_ADD:
      /* AC = E + AC */
      do_memory_write (ac, do_add (do_memory_read (ac, 0), do_memory_read (e_addr, 0)));
      micropc = 0;
      break;

    case 100 + OP_ADDI:
      /* AC = AC + 0,,E */
      do_memory_write (ac, do_add (form_word (0, e_addr), do_memory_read (ac, 0)));
      micropc = 0;
      break;

    case 100 + OP_ADDM:
      /* E = E + AC */
      do_memory_write (e_addr, do_add (do_memory_read (ac, 0), do_memory_read (e_addr, 0)));
      micropc = 0;
      break;

    case 100 + OP_ADDB:
      /* E = E + AC, AC = E + AC */
      br = do_add (do_memory_read (e_addr, 0), do_memory_read (ac, 0));
      do_memory_write (ac, br);
      do_memory_write (e_addr, br);
      micropc = 0;
      break;

    case 100 + OP_SUB:
      /* AC = E - AC */
      do_memory_write (ac, do_sub (do_memory_read (ac, 0), do_memory_read (e_addr, 0)));
      micropc = 0;
      break;

    case 100 + OP_SUBI:
      /* AC = AC - 0,,E */
      do_memory_write (ac, do_sub (do_memory_read (ac, 0), form_word (0, e_addr)));
      micropc = 0;
      break;

    case 100 + OP_SUBM:
      /* E = E - AC */
      do_memory_write (e_addr, do_sub (do_memory_read (ac, 0), do_memory_read (e_addr, 0)));
      micropc = 0;
      break;

    case 100 + OP_SUBB:
      /* E = E - AC, AC = E - AC */
      br = do_sub (do_memory_read (e_addr, 0), do_memory_read (ac, 0));
      do_memory_write (ac, br);
      do_memory_write (e_addr, br);
      micropc = 0;
      break;

/* OP_MUL needs doubleword math */

    case 100 + OP_IMUL:
      /* AC = E * AC */
      do_memory_write (ac, do_imul (do_memory_read (ac, 0), do_memory_read (e_addr, 0)));
      micropc = 0;
      break;

    case 100 + OP_IMULI:
      /* AC = AC * 0,,E */
      do_memory_write (ac, do_imul (form_word (0, e_addr), do_memory_read (ac, 0)));
      micropc = 0;
      break;

    case 100 + OP_IMULM:
      /* E = E * AC */
      do_memory_write (e_addr, do_imul (do_memory_read (ac, 0), do_memory_read (e_addr, 0)));
      micropc = 0;
      break;

    case 100 + OP_IMULB:
      /* E = E * AC, AC = E * AC */
      br = do_imul (do_memory_read (e_addr, 0), do_memory_read (ac, 0));
      do_memory_write (ac, br);
      do_memory_write (e_addr, br);
      micropc = 0;
      break;

/* IDIV and DIV don't have math code either */

    case 100 + OP_IDIV:
      /* AC = E / AC, AC+1 = REMAINDER */
      br = do_idiv (do_memory_read (ac, 0), do_memory_read (e_addr, 0));
      do_memory_write (ac, br);
      do_memory_write (ac + 1, arx);
      NXT_INST;

    case 100 + OP_IDIVI:
      /* AC = E_ADDR / AC, AC+1 = REMAINDER */
      br = do_idiv (do_memory_read (ac, 0), form_word (0, e_addr));
      do_memory_write (ac, br);
      do_memory_write (ac + 1, arx);
      NXT_INST;

    case 100 + OP_IDIVM:
      /* E = E / AC, AC+1 = REMAINDER */
      br = do_idiv (do_memory_read (ac, 0), do_memory_read (e_addr, 0));
      do_memory_write (e_addr, br);
      NXT_INST;

    case 100 + OP_IDIVB:
      /* AC = E / AC, AC+1 = REMAINDER, E = E / AC */
      br = do_idiv (do_memory_read (ac, 0), do_memory_read (e_addr, 0));
      do_memory_write (ac, br);
      do_memory_write (ac + 1, arx);
      do_memory_write (e_addr, br);
      NXT_INST;


/* None of the double precision stuff has math code */

/* Floating Point is straight out. */

/* BOOLEAN FUNCTIONS */

    case 100 + OP_SETZ:
      /* 0 > ac */
      do_memory_write (ac, 0);
      micropc = 0;
      break;

    case 100 + OP_SETZI:
      /* 0 > AC */
      do_memory_write (ac, 0);
      micropc = 0;
      break;

    case 100 + OP_SETZM:
      /* 0 > E_ADDR */
      do_memory_write (e_addr, 0);
      micropc = 0;
      break;

    case 100 + OP_SETZB:
      /* 0 > E and AC */
      do_memory_write (e_addr, 0);
      do_memory_write (ac, 0);
      micropc = 0;
      break;

    case 100 + OP_SETO:
      /* 1 > AC */
      do_memory_write (ac, 0777777777777LL);
      micropc = 0;
      break;

    case 100 + OP_SETOI:
      /* 1 to AC */
      do_memory_write (ac, 0777777777777LL);
      micropc = 0;
      break;

    case 100 + OP_SETOM:
      /* 1 to E */
      do_memory_write (e_addr, 0777777777777LL);
      micropc = 0;
      break;

    case 100 + OP_SETOB:
      /* 1 to AC and E */
      do_memory_write (e_addr, 0777777777777LL);
      do_memory_write (ac, 0777777777777LL);
      micropc = 0;
      break;

    case 100 + OP_SETA:
      /* AC > AC */
      do_memory_write (ac, do_memory_read (ac, 0));
      micropc = 0;
      break;

    case 100 + OP_SETAI:
      /* AC > AC */
      do_memory_write (ac, do_memory_read (ac, 0));
      micropc = 0;
      break;

    case 100 + OP_SETAM:
      /* AC > E */
      do_memory_write (e_addr, do_memory_read (ac, 0));
      micropc = 0;
      break;

    case 100 + OP_SETAB:
      /* AC > E and AC */
      do_memory_write (e_addr, do_memory_read (ac, 0));
      do_memory_write (ac, do_memory_read (ac, 0));
      micropc = 0;
      break;

/* DEC diagnostics would run on a dead whale.
   -- Mel Ferentz */

    case 100 + OP_SETCA:
      /* ~AC > AC */
      do_memory_write (ac, ((~do_memory_read (ac, 0)) & 0777777777777LL));
      micropc = 0;
      break;

    case 100 + OP_SETCAI:
      /* ~AC > AC */
      do_memory_write (ac, ((~do_memory_read (ac, 0)) & 0777777777777LL));
      micropc = 0;
      break;

    case 100 + OP_SETCAM:
      /* ~AC > E */
      do_memory_write (e_addr, ((~do_memory_read (ac, 0)) & 0777777777777LL));
      micropc = 0;
      break;

    case 100 + OP_SETCAB:
      /* ~AC to E and AC */
      do_memory_write (e_addr, ((~do_memory_read (ac, 0)) & 0777777777777LL));
      do_memory_write (ac, ((~do_memory_read (ac, 0)) & 0777777777777LL));
      micropc = 0;
      break;

/* HELLO */
    case 100 + OP_SETM:
      /* E > AC */
      do_memory_write (ac, do_memory_read (e_addr, 0));
      micropc = 0;
      break;

    case 100 + OP_SETMI:
      /* E > AC */
      /* NOTE: IF THIS IS A NONZERO SECTION, THIS IS XMOVEI */
      if (cpu_section != 0)
	{
	  /* XMOVEI */
	  /* If E is not a local AC address, clear AC bits 0-5,
	     and put the global effective address E in AC 6-35 */
	  /* If E is a local AC address, put 1 in AC lf, E in AC RT */
	  if (global_mode)
	    {
	      /* This is set if the e_addr calc went global */
	      if (((e_addr & 0007777000000) >> 18) == cpu_section)
		{
		  /* Same section */
		  if (get_rt_half (e_addr) <= 017)
		    {
		      /* AC address */
		      do_memory_write (ac, form_word (01, e_addr));
		      NXT_INST;
		    }
		  /* Not AC */
		}
	      /* Not same section */
	      do_memory_write (ac, form_word (cpu_section, e_addr));
	      NXT_INST;
	    }
	  /* Not global mode */
	  if (get_rt_half (e_addr) <= 017)
	    {
	      /* AC address */
	      do_memory_write (ac, form_word (01, e_addr));
	      NXT_INST;
	    }
	  /* Not AC */
	  do_memory_write (ac, form_word (cpu_section, e_addr));
	  NXT_INST;
	}
      /* Not XMOVEI. */
      do_memory_write (ac, form_word (0, e_addr));
      micropc = 0;
      break;

    case 100 + OP_SETMM:
      /* E > E */
      do_memory_write (e_addr, do_memory_read (e_addr, 0));
      micropc = 0;
      break;

    case 100 + OP_SETMB:
      /* E > E and AC */
      do_memory_write (e_addr, do_memory_read (e_addr, 0));
      do_memory_write (ac, do_memory_read (e_addr, 0));
      micropc = 0;
      break;

    case 100 + OP_SETCM:
      /* ~E > AC */
      do_memory_write (ac, ((~do_memory_read (e_addr, 0)) & 0777777777777LL));
      micropc = 0;
      break;

    case 100 + OP_SETCMI:
      /* ~E > AC */
      do_memory_write (ac, ((~form_word (0, e_addr)) & 0777777777777LL));
      micropc = 0;
      break;

    case 100 + OP_SETCMM:
      /* ~E > E */
      do_memory_write (e_addr, ((~do_memory_read (e_addr, 0)) & 0777777777777LL));
      micropc = 0;
      break;

    case 100 + OP_SETCMB:
      /* ~E to E and AC */
      do_memory_write (ac, ((~do_memory_read (e_addr, 0)) & 0777777777777LL));
      do_memory_write (e_addr, ((~do_memory_read (e_addr, 0)) & 0777777777777LL));
      micropc = 0;
      break;

    case 100 + OP_AND:
      /* AC & E > AC */
      do_memory_write (ac, (do_memory_read (ac, 0) & do_memory_read (e_addr, 0)));
      micropc = 0;
      break;

    case 100 + OP_ANDI:
      /* AC & 0,,E > AC */
      do_memory_write (ac, (do_memory_read (ac, 0) & form_word (0, e_addr)));
      micropc = 0;
      break;

    case 100 + OP_ANDM:
      /* AC & E > E */
      do_memory_write (e_addr, (do_memory_read (ac, 0) & do_memory_read (e_addr, 0)));
      micropc = 0;
      break;

    case 100 + OP_ANDB:
      /* AC & E > E and AC */
      br = (do_memory_read (ac, 0) & do_memory_read (e_addr, 0));
      do_memory_write (ac, br);
      do_memory_write (e_addr, br);
      micropc = 0;
      break;

    case 100 + OP_ANDCA:
      /* ~AC & E > E */
      do_memory_write (ac, ((~do_memory_read (ac, 0)) & do_memory_read (e_addr, 0)));
      micropc = 0;
      break;

    case 100 + OP_ANDCAI:
      /* ~AC & 0,,E > AC */
      do_memory_write (ac, (form_word (0, e_addr) & (~do_memory_read (ac, 0))));
      micropc = 0;
      break;

    case 100 + OP_ANDCAM:
      /* ~AC & E > E */
      do_memory_write (e_addr, ((~do_memory_read (ac, 0)) & do_memory_read (e_addr, 0)));
      micropc = 0;
      break;

    case 100 + OP_ANDCAB:
      /* ~AC & E > E and AC */
      br = ((~do_memory_read (ac, 0)) & do_memory_read (e_addr, 0));
      do_memory_write (e_addr, br);
      do_memory_write (ac, br);
      micropc = 0;
      break;

    case 100 + OP_ANDCM:
      /* AC & ~E > AC */
      do_memory_write (ac, ((~do_memory_read (e_addr, 0)) & do_memory_read (ac, 0)));
      micropc = 0;
      break;

    case 100 + OP_ANDCMI:
      /* AC & ~0,,E > AC */
      do_memory_write (ac, ((~form_word (0, e_addr)) & do_memory_read (ac, 0)));
      micropc = 0;
      break;

    case 100 + OP_ANDCMM:
      /* AC & ~E > E */
      do_memory_write (e_addr, (~(do_memory_read (e_addr, 0)) & do_memory_read (ac, 0)));
      micropc = 0;
      break;

    case 100 + OP_ANDCMB:
      /* AC & ~E > AC and E */
      br = (~(do_memory_read (e_addr, 0)) & do_memory_read (ac, 0));
      do_memory_write (ac, br);
      do_memory_write (e_addr, br);
      micropc = 0;
      break;

/* HELLO */

    case 100 + OP_ANDCB:
      /* ~AC & ~E > AC */
      do_memory_write (ac, ((~do_memory_read (e_addr, 0)) & ~do_memory_read (ac, 0)));
      micropc = 0;
      break;

    case 100 + OP_ANDCBI:
      /* ~AC & ~0,,E > AC */
      do_memory_write (ac, ((~form_word (0, e_addr)) & ~do_memory_read (ac, 0)));
      micropc = 0;
      break;

    case 100 + OP_ANDCBM:
      /* ~AC & ~E > E */
      do_memory_write (e_addr, (~(do_memory_read (e_addr, 0)) & ~do_memory_read (ac, 0)));
      micropc = 0;
      break;

    case 100 + OP_ANDCBB:
      /* ~AC & ~E > AC and E */
      br = (~(do_memory_read (e_addr, 0)) & ~do_memory_read (ac, 0));
      do_memory_write (ac, br);
      do_memory_write (e_addr, br);
      micropc = 0;
      break;

    case 100 + OP_OR:
      /* AC | E > AC */
      do_memory_write (ac, (do_memory_read (ac, 0) | do_memory_read (e_addr, 0)));
      micropc = 0;
      break;

    case 100 + OP_ORI:
      /* AC | 0,,E > AC */
      do_memory_write (ac, (form_word (0, e_addr) | do_memory_read (ac, 0)));
      micropc = 0;
      break;

    case 100 + OP_ORM:
      /* AC | E > E */
      do_memory_write (e_addr, (do_memory_read (ac, 0) | do_memory_read (e_addr, 0)));
      micropc = 0;
      break;

    case 100 + OP_ORB:
      /* AC | E > E and AC */
      br = (do_memory_read (ac, 0) | do_memory_read (e_addr, 0));
      do_memory_write (ac, br);
      do_memory_write (e_addr, br);
      micropc = 0;
      break;

/* Konnichiwa */

    case 100 + OP_ORCA:
      /* ~AC | E > AC */
      do_memory_write (ac, ((~do_memory_read (ac, 0)) | do_memory_read (e_addr, 0)));
      micropc = 0;
      break;

    case 100 + OP_ORCAI:
      /* ~AC | 0,,E > AC */
      do_memory_write (ac, (form_word (0, e_addr) | (~do_memory_read (ac, 0))));
      micropc = 0;
      break;

    case 100 + OP_ORCAM:
      /* ~AC | E > E */
      do_memory_write (e_addr, (~(do_memory_read (ac, 0)) | do_memory_read (e_addr, 0)));
      micropc = 0;
      break;

    case 100 + OP_ORCAB:
      /* ~AC | E > E and AC */
      br = ((~do_memory_read (ac, 0)) | do_memory_read (e_addr, 0));
      do_memory_write (ac, br);
      do_memory_write (e_addr, br);
      micropc = 0;
      break;

    case 100 + OP_ORCM:
      /* AC | ~E > AC */
      do_memory_write (ac, (do_memory_read (ac, 0) | (~do_memory_read (e_addr, 0))));
      micropc = 0;
      break;

    case 100 + OP_ORCMI:
      /* AC | ~0,,E > AC */
      do_memory_write (ac, ((~form_word (0, e_addr)) | do_memory_read (ac, 0)));
      micropc = 0;
      break;

    case 100 + OP_ORCMM:
      /* AC | ~E > E */
      do_memory_write (e_addr, (do_memory_read (ac, 0) | (~do_memory_read (e_addr, 0))));
      micropc = 0;
      break;

    case 100 + OP_ORCMB:
      /* AC | ~E > E and AC */
      br = (do_memory_read (ac, 0) | (~do_memory_read (e_addr, 0)));
      do_memory_write (ac, br);
      do_memory_write (e_addr, br);
      micropc = 0;
      break;

    case 100 + OP_ORCB:
      /* ~AC | ~E > AC */
      do_memory_write (ac, ((~do_memory_read (ac, 0)) | (~do_memory_read (e_addr, 0))));
      micropc = 0;
      break;

    case 100 + OP_ORCBI:
      /* ~AC | ~0,,E > AC */
      do_memory_write (ac, ((~form_word (0, e_addr)) | (~do_memory_read (ac, 0))));
      micropc = 0;
      break;

    case 100 + OP_ORCBM:
      /* ~AC | ~E > E */
      do_memory_write (e_addr, ((~do_memory_read (ac, 0)) | (~do_memory_read (e_addr, 0))));
      micropc = 0;
      break;

    case 100 + OP_ORCBB:
      /* ~AC | ~E > E and AC */
      br = ((~do_memory_read (ac, 0)) | (~do_memory_read (e_addr, 0)));
      do_memory_write (ac, br);
      do_memory_write (e_addr, br);
      micropc = 0;
      break;

    case 100 + OP_XOR:
      /* AC ^ E > AC */
      do_memory_write (ac, (do_memory_read (ac, 0) ^ do_memory_read (e_addr, 0)));
      micropc = 0;
      break;

    case 100 + OP_XORI:
      /* AC ^ 0,,E > AC */
      do_memory_write (ac, (form_word (0, e_addr) ^ do_memory_read (ac, 0)));
      micropc = 0;
      break;

    case 100 + OP_XORM:
      /* AC ^ E > E */
      do_memory_write (e_addr, (do_memory_read (ac, 0) ^ do_memory_read (e_addr, 0)));
      micropc = 0;
      break;

    case 100 + OP_XORB:
      /* AC ^ E > E and AC */
      br = (do_memory_read (ac, 0) ^ do_memory_read (e_addr, 0));
      do_memory_write (ac, br);
      do_memory_write (e_addr, br);
      micropc = 0;
      break;

    case 100 + OP_EQV:
      /* ~(AC ^ E) > AC */
      do_memory_write (ac, (~(do_memory_read (ac, 0) ^ do_memory_read (e_addr, 0))));
      micropc = 0;
      break;

    case 100 + OP_EQVI:
      /* ~(AC ^ 0,,E) > AC */
      do_memory_write (ac, (~(do_memory_read (ac, 0) ^ form_word (0, e_addr))));
      micropc = 0;
      break;

    case 100 + OP_EQVM:
      /* ~(AC ^ E) > E */
      do_memory_write (e_addr, (~(do_memory_read (ac, 0) ^ do_memory_read (e_addr, 0))));
      micropc = 0;
      break;

    case 100 + OP_EQVB:
      /* ~(AC ^ E) > E and AC */
      br = (~(do_memory_read (ac, 0) ^ do_memory_read (e_addr, 0)));
      do_memory_write (ac, br);
      do_memory_write (e_addr, br);
      micropc = 0;
      break;


/* SHIFT INSTR */

    case 100 + OP_LSH:
      /* Logical Shift */
      /* 1.  Are we going left or right? */
      br = do_memory_read (ac, 0);
      if (e_addr & 0400000)
	{
	  /* Right. */
	  br = br >> (e_addr & 0377777);	/* Don't use the sign! */
	  do_memory_write (ac, br & 0777777777777LL);
	  micropc = 0;
	  break;
	}
      br = br << e_addr;
      do_memory_write (ac, br & 0777777777777LL);
      micropc = 0;
      break;

    case 100 + OP_LSHC:
      /* Logical Shift Combined */
      /* This is the model for future shift/rotate toys */
      /* 1. Fetch in the operands */
      ar = do_memory_read (ac, 0);
      arx = do_memory_read (ac + 1, 0);
      /* 2. Build the shift count in sctr */
      if (e_addr & 0400000)
	{
	  sctr = 0 - e_addr;
	}
      else
	{
	  sctr = e_addr;
	}
      /* 3. Core of operation. */
      while (sctr < 0)
	{
	  ar = ar << 1;		/* Shift ar */
	  arx = arx << 1;	/* Shift arx */
	  if (ar & 01000000000000LL)
	    {			/* Carry? */
	      arx = arx | 1;	/* Deal with it. */
	      ar = ar & 0777777777777LL;	/* And clear it */
	    }
	  sctr++;		/* Head for zero */
	}			/* Loop */
      while (sctr > 0)
	{
	  if (arx & 01)
	    {			/* Carry needed? */
	      ar = ar | 01000000000000LL;	/* Set it */
	    }
	  arx = arx >> 1;	/* Shift arx */
	  ar = ar >> 1;		/* Shift ar */
	  sctr--;		/* Head for zero */
	}			/* Loop */
      /* 4. Done here */
      do_memory_write (ac, ar);
      do_memory_write (ac + 1, arx);	/* STORE */
      micropc = 0;
      break;			/* NXT INSTR */

    case 100 + OP_ROT:
      /* 1. Fetch in the operands */
      ar = do_memory_read (ac, 0);
      /* 2. Build the shift count in sctr */
      if (e_addr & 0400000)
	{
	  sctr = 0 - e_addr;
	}
      else
	{
	  sctr = e_addr;
	}
      /* 3. Core of operation. */
      while (sctr < 0)
	{
	  ar = ar << 1;		/* Shift */
	  if (ar & 01000000000000LL)
	    {			/* Carry needed? */
	      ar = ar | 1;	/* Do it. */
	      ar = ar & 0777777777777LL;	/* Fix it. */
	    }
	  sctr++;		/* Head for zero */
	}			/* Loop */
      while (sctr > 0)
	{
	  if (ar & 01)
	    {			/* Carry needed? */
	      ar = ar | 01000000000000LL;	/* Do it. */
	    }
	  ar = ar >> 1;		/* Shift */
	  sctr--;		/* Head for zero */
	}			/* Loop */
      /* 4. Done here */
      do_memory_write (ac, ar);	/* STORE */
      micropc = 0;
      break;			/* NXT INSTR */

    case 100 + OP_ROTC:
      /* 1. Fetch in the operands */
      ar = do_memory_read (ac, 0);
      arx = do_memory_read (ac + 1, 0);
      /* 2. Build the shift count in sctr */
      if (e_addr & 0400000)
	{
	  sctr = 0 - e_addr;
	}
      else
	{
	  sctr = e_addr;
	}
      /* 3. Core of operation. */
      while (sctr < 0)
	{
	  ar = ar << 1;		/* Shift */
	  arx = arx << 1;	/* Shift again */
	  if (ar & 01000000000000LL)
	    {			/* Carry needed? */
	      arx = arx | 1;	/* Do it. */
	      ar = ar & 0777777777777LL;	/* Fix it. */
	    }
	  if (arx & 01000000000000LL)
	    {			/* Carry here needed? */
	      ar = ar | 1;	/* Do it. */
	      arx = arx & 0777777777777LL;	/* Fix it */
	    }
	  sctr++;		/* Head for zero */
	}			/* Loop */
      while (sctr > 0)
	{
	  if (ar & 01)
	    {			/* Carry needed? */
	      arx = arx | 01000000000000LL;	/* Do it. */
	    }
	  if (arx & 01)
	    {
	      ar = ar | 01000000000000LL;	/* Do this */
	    }
	  ar = ar >> 1;		/* Shift */
	  arx = arx >> 1;	/* Here too */
	  sctr--;		/* Head for zero */
	}			/* Loop */
      /* 4. Done here */
      do_memory_write (ac, ar);	/* STORE */
      do_memory_write (ac + 1, arx);
      micropc = 0;
      break;			/* NXT INSTR */

/* ASH needs division */
/* ASHC needs doubleword math */

    case 100 + OP_AOBJP:
      /* Add One to Both Half of AC and Jump if Positive */
      br = do_memory_read (ac, 0);	/* Fetch */
      br = form_word (get_lf_half (br) + 1, get_rt_half (br) + 1);	/* Add */
      do_memory_write (ac, br);	/* Store */
      if (!br & 0400000000000LL)
	{			/* Is it positive? */
	  pc = form_word (get_lf_half (pc), e_addr);	/* Jump to E */
	}
      micropc = 0;
      break;			/* NXT INSTR */

    case 100 + OP_AOBJN:
      /* Add One to Both Half of AC and Jump if Negative */
      br = do_memory_read (ac, 0);	/* Fetch */
      br = form_word (get_lf_half (br) + 1, get_rt_half (br) + 1);	/* Add */
      do_memory_write (ac, br);	/* Store */
      if (br & 0400000000000LL)
	{			/* Is it negative? */
	  pc = form_word (get_lf_half (pc), e_addr);	/* Jump to E */
	}
      micropc = 0;
      break;			/* NXT INSTR */

    case 100 + OP_CAI:
    case 100 + OP_CAIL:
    case 100 + OP_CAIE:
    case 100 + OP_CAILE:
    case 100 + OP_CAIA:
    case 100 + OP_CAIGE:
    case 100 + OP_CAIN:
    case 100 + OP_CAIG:
      /* Compare AC Immediate */
      br = do_sub (do_memory_read (ac, 0), form_word (0, e_addr));
      /* Skip if condition satisfied */
      switch (opc & 07)
	{
	case 00:
	  /* CAI */
	  /* Don't skip. */
	  break;
	case 01:
	  /* CAIL */
	  if ((br & 0400000000000LL) == 0400000000000LL)
	    {
	      /* Negative, E was bigger. */
	      DO_SKIP;
	    }
	  break;
	case 02:
	  /* CAIE */
	  if (br == 0)
	    {
	      DO_SKIP;
	    }
	  break;
	case 03:
	  /* CAILE */
	  if (((br & 0400000000000LL) == 0400000000000LL) || br == 0)
	    {
	      DO_SKIP;
	    }
	  break;
	case 04:
	  /* CAIA */
	  DO_SKIP;
	  break;
	case 05:
	  /* CAIGE */
	  if (((br & 0400000000000LL) == 0) || (br == 0))
	    {
	      DO_SKIP;
	    }
	  break;
	case 06:
	  /* CAIN */
	  if (br != 0)
	    {
	      DO_SKIP;
	    }
	  break;
	case 07:
	  /* CAIG */
	  if (((br & 0400000000000LL) == 0) && br > 0)
	    {
	      DO_SKIP;
	    }
	  break;
	default:
	  /* What the hell? */
	  printf ("%%CPU: CAI*: ZERO-GRAVITY CONDITION!\n");
	  goto do_halt;
	  break;
	}
      NXT_INST;


/* We are geared toward the average rather than the exceptional. */

    case 100 + OP_CAM:
    case 100 + OP_CAML:
    case 100 + OP_CAME:
    case 100 + OP_CAMLE:
    case 100 + OP_CAMA:
    case 100 + OP_CAMGE:
    case 100 + OP_CAMN:	/* Camnit! :) */
    case 100 + OP_CAMG:
      /* Compare AC with Memory */
      br = do_sub (do_memory_read (ac, 0), do_memory_read (e_addr, 0));
      /* Skip if condition satisfied */
      switch (opc & 07)
	{
	case 00:
	  /* CAM */
	  /* Don't skip. */
	  break;
	case 01:
	  /* CAML */
	  if ((br & 0400000000000LL) == 0400000000000LL)
	    {
	      /* Negative, E was bigger. */
	      DO_SKIP;
	    }
	  break;
	case 02:
	  /* CAME */
	  if (br == 0)
	    {
	      DO_SKIP;
	    }
	  break;
	case 03:
	  /* CAMLE */
	  if (((br & 0400000000000LL) == 0400000000000LL) || br == 0)
	    {
	      DO_SKIP;
	    }
	  break;
	case 04:
	  /* CAMA */
	  DO_SKIP;
	  break;
	case 05:
	  /* CAMGE */
	  if (((br & 0400000000000LL) == 0) || (br == 0))
	    {
	      DO_SKIP;
	    }
	  break;
	case 06:
	  /* CAMN */
	  if (br != 0)
	    {
	      DO_SKIP;
	    }
	  break;
	case 07:
	  /* CAMG */
	  if (((br & 0400000000000LL) == 0) && br > 0)
	    {
	      DO_SKIP;
	    }
	  break;
	default:
	  /* What the hell? */
	  printf ("%%CPU: CAM*: MUJUROKU JOUKAI!\n");
	  goto do_halt;
	  break;
	}
      NXT_INST;

    case 100 + OP_JUMP:
    case 100 + OP_JUMPL:
    case 100 + OP_JUMPE:
    case 100 + OP_JUMPLE:
    case 100 + OP_JUMPA:
    case 100 + OP_JUMPGE:
    case 100 + OP_JUMPN:
    case 100 + OP_JUMPG:
      /* Compare 0 with AC */
      br = do_sub (do_memory_read (ac, 0), 0);
      /* Jump if condition satisfied */
      switch (opc & 07)
	{
	case 00:
	  /* JUMP */
	  /* Don't jump. */
	  break;
	case 01:
	  /* JUMPL */
	  if ((br & 0400000000000LL) == 0400000000000LL)
	    {
	      /* Negative #. */
	      DO_JUMP;
	    }
	  break;
	case 02:
	  /* JUMPE */
	  if (br == 0)
	    {
	      DO_JUMP;
	    }
	  break;
	case 03:
	  /* JUMPLE */
	  if (((br & 0400000000000LL) == 0400000000000LL) || br == 0)
	    {
	      DO_JUMP;
	    }
	  break;
	case 04:
	  /* JUMPA */
	  DO_JUMP;
	  break;
	case 05:
	  /* JUMPGE */
	  if (((br & 0400000000000LL) == 0) || (br == 0))
	    {
	      DO_JUMP;
	    }
	  break;
	case 06:
	  /* JUMPN */
	  if (br != 0)
	    {
	      DO_JUMP;
	    }
	  break;
	case 07:
	  /* JUMPG */
	  if (((br & 0400000000000LL) == 0) && br > 0)
	    {
	      DO_JUMP;
	    }
	  break;
	default:
	  /* What the hell? */
	  printf ("%%CPU: JUMP*: SOMETHING STINKS IN MINNESOTA\n");
	  goto do_halt;
	  break;
	}
      NXT_INST;


    case 100 + OP_SKIP:
    case 100 + OP_SKIPL:
    case 100 + OP_SKIPE:
    case 100 + OP_SKIPLE:
    case 100 + OP_SKIPA:
    case 100 + OP_SKIPGE:
    case 100 + OP_SKIPN:
    case 100 + OP_SKIPG:
      /* Compare 0 with E */
      br = do_sub (do_memory_read (e_addr, 0), 0);
      /* Skip if condition satisfied */
      switch (opc & 07)
	{
	case 00:
	  /* SKIP */
	  /* Don't skip. */
	  break;
	case 01:
	  /* SKIPL */
	  if ((br & 0400000000000LL) == 0400000000000LL)
	    {
	      /* Negative #. */
	      DO_SKIP;
	    }
	  break;
	case 02:
	  /* SKIPE */
	  if (br == 0)
	    {
	      DO_SKIP;
	    }
	  break;
	case 03:
	  /* SKIPLE */
	  if (((br & 0400000000000LL) == 0400000000000LL) || br == 0)
	    {
	      DO_SKIP;
	    }
	  break;
	case 04:
	  /* SKIPA */
	  DO_SKIP;
	  break;
	case 05:
	  /* SKIPGE */
	  if (((br & 0400000000000LL) == 0) || (br == 0))
	    {
	      DO_SKIP;
	    }
	  break;
	case 06:
	  /* SKIPN */
	  if (br != 0)
	    {
	      DO_SKIP;
	    }
	  break;
	case 07:
	  /* SKIPG */
	  if (((br & 0400000000000LL) == 0) && br > 0)
	    {
	      DO_SKIP;
	    }
	  break;
	default:
	  /* What the hell? */
	  printf ("%%CPU: SKIP*: SOMETHING STUPID HAPPENED\n");
	  goto do_halt;
	  break;
	}
      NXT_INST;

    case 100 + OP_AOJ:
    case 100 + OP_AOJL:
    case 100 + OP_AOJE:
    case 100 + OP_AOJLE:
    case 100 + OP_AOJA:
    case 100 + OP_AOJGE:
    case 100 + OP_AOJN:
    case 100 + OP_AOJG:
      /* Compare 0 with AC+1 */
      br = do_memory_read (ac, 0);
      br = do_add (br, 01LL);
      do_memory_write (ac, br);	/* DO ADD */
      br = do_sub (br, 0);
      /* Skip if condition satisfied */
      switch (opc & 07)
	{
	case 00:
	  /* AOJ */
	  /* Don't jump. */
	  break;
	case 01:
	  /* AOJL */
	  if ((br & 0400000000000LL) == 0400000000000LL)
	    {
	      /* Negative #. */
	      DO_JUMP;
	    }
	  break;
	case 02:
	  /* AOJE */
	  if (br == 0)
	    {
	      DO_JUMP;
	    }
	  break;
	case 03:
	  /* AOJLE */
	  if (((br & 0400000000000LL) == 0400000000000LL) || br == 0)
	    {
	      DO_JUMP;
	    }
	  break;
	case 04:
	  /* AOJA */
	  DO_JUMP;
	  break;
	case 05:
	  /* AOJGE */
	  if (((br & 0400000000000LL) == 0) || (br == 0))
	    {
	      DO_JUMP;
	    }
	  break;
	case 06:
	  /* AOJN */
	  if (br != 0)
	    {
	      DO_JUMP;
	    }
	  break;
	case 07:
	  /* AOJG */
	  if (((br & 0400000000000LL) == 0) && br > 0)
	    {
	      DO_JUMP;
	    }
	  break;
	default:
	  /* What the hell? */
	  printf ("%%CPU: AOJ*: COLOR ME CHIBI-USA PINK\n");
	  goto do_halt;
	  break;
	}
      NXT_INST;

/* Cat! Pytr! Watch! Watch!  They're going to do more magic! */

    case 100 + OP_SOJ:
    case 100 + OP_SOJL:
    case 100 + OP_SOJE:
    case 100 + OP_SOJLE:
    case 100 + OP_SOJA:
    case 100 + OP_SOJGE:
    case 100 + OP_SOJN:
    case 100 + OP_SOJG:
      /* Compare 0 with AC-1 */
      br = do_memory_read (ac, 0);
      br = do_sub (br, 01LL);
      do_memory_write (ac, br);	/* DO ADD */
      br = do_sub (br, 0);
      /* Skip if condition satisfied */
      switch (opc & 07)
	{
	case 00:
	  /* SOJ */
	  /* Don't jump. */
	  break;
	case 01:
	  /* SOJL */
	  if ((br & 0400000000000LL) == 0400000000000LL)
	    {
	      /* Negative #. */
	      DO_JUMP;
	    }
	  break;
	case 02:
	  /* SOJE */
	  if (br == 0)
	    {
	      DO_JUMP;
	    }
	  break;
	case 03:
	  /* SOJLE */
	  if (((br & 0400000000000LL) == 0400000000000LL) || br == 0)
	    {
	      DO_JUMP;
	    }
	  break;
	case 04:
	  /* SOJA */
	  DO_JUMP;
	  break;
	case 05:
	  /* SOJGE */
	  if (((br & 0400000000000LL) == 0) || (br == 0))
	    {
	      DO_JUMP;
	    }
	  break;
	case 06:
	  /* SOJN */
	  if (br != 0)
	    {
	      DO_JUMP;
	    }
	  break;
	case 07:
	  /* SOJG */
	  if (((br & 0400000000000LL) == 0) && br > 0)
	    {
	      DO_JUMP;
	    }
	  break;
	default:
	  /* What the hell? */
	  printf ("%%CPU: SOJ*: SAKATCHI-SENSEI SAYS HI\n");
	  goto do_halt;
	  break;
	}
      NXT_INST;

/* #include <the-biggest-ball-of-twine-in-minnesota.h> */

    case 100 + OP_AOS:
    case 100 + OP_AOSL:
    case 100 + OP_AOSE:
    case 100 + OP_AOSLE:
    case 100 + OP_AOSA:
    case 100 + OP_AOSGE:
    case 100 + OP_AOSN:
    case 100 + OP_AOSG:
      /* Compare 0 with E+1 */
      br = do_memory_read (e_addr, 0);
      br = do_add (br, 01LL);
      do_memory_write (e_addr, br);	/* DO ADD */
      br = do_sub (br, 0);
      /* Skip if condition satisfied */
      switch (opc & 07)
	{
	case 00:
	  /* AOS */
	  /* Don't skip. */
	  break;
	case 01:
	  /* AOSL */
	  if ((br & 0400000000000LL) == 0400000000000LL)
	    {
	      /* Negative #. */
	      DO_SKIP;
	    }
	  break;
	case 02:
	  /* AOSE */
	  if (br == 0)
	    {
	      DO_SKIP;
	    }
	  break;
	case 03:
	  /* AOSLE */
	  if (((br & 0400000000000LL) == 0400000000000LL) || br == 0)
	    {
	      DO_SKIP;
	    }
	  break;
	case 04:
	  /* AOSA */
	  DO_SKIP;
	  break;
	case 05:
	  /* AOSGE */
	  if (((br & 0400000000000LL) == 0) || (br == 0))
	    {
	      DO_SKIP;
	    }
	  break;
	case 06:
	  /* AOSN */
	  if (br != 0)
	    {
	      DO_SKIP;
	    }
	  break;
	case 07:
	  /* AOSG */
	  if (((br & 0400000000000LL) == 0) && br > 0)
	    {
	      DO_SKIP;
	    }
	  break;
	default:
	  /* BSSO kicks ass! */
	  printf ("%%CPU: AOS*: DON'T EVEN THINK ABOUT IT - ANTARES\n");
	  goto do_halt;
	  break;
	}
      NXT_INST;

/* "When you have a sweet smile, the world truly becomes sweeter than the 
   best candy" - Peruru , SailorMoon SuperS Movie (Watch it!) */

    case 100 + OP_SOS:		/* Tasukete! */
    case 100 + OP_SOSL:
    case 100 + OP_SOSE:
    case 100 + OP_SOSLE:
    case 100 + OP_SOSA:
    case 100 + OP_SOSGE:
    case 100 + OP_SOSN:
    case 100 + OP_SOSG:
      /* Compare 0 with E-1 */
      br = do_memory_read (e_addr, 0);
      br = do_add (br, 01LL);
      do_memory_write (e_addr, br);	/* DO ADD */
      br = do_sub (br, 0);
      /* Skip if condition satisfied */
      switch (opc & 07)
	{
	case 00:
	  /* SOS */
	  /* Don't skip. */
	  break;
	case 01:
	  /* SOSL */
	  if ((br & 0400000000000LL) == 0400000000000LL)
	    {
	      /* Negative #. */
	      DO_SKIP;
	    }
	  break;
	case 02:
	  /* SOSE */
	  if (br == 0)
	    {
	      DO_SKIP;
	    }
	  break;
	case 03:
	  /* SOSLE */
	  if (((br & 0400000000000LL) == 0400000000000LL) || br == 0)
	    {
	      DO_SKIP;
	    }
	  break;
	case 04:
	  /* SOSA */
	  DO_SKIP;
	  break;
	case 05:
	  /* SOSGE */
	  if (((br & 0400000000000LL) == 0) || (br == 0))
	    {
	      DO_SKIP;
	    }
	  break;
	case 06:
	  /* SOSN */
	  if (br != 0)
	    {
	      DO_SKIP;
	    }
	  break;
	case 07:
	  /* SOSG */
	  if (((br & 0400000000000LL) == 0) && br > 0)
	    {
	      DO_SKIP;
	    }
	  break;
	default:
	  /* BSSO kicks ass! */
	  printf ("%%CPU: SOS*: JAN-KEN-PON! AI-KO DESHOU!\n");
	  goto do_halt;
	  break;
	}
      NXT_INST;

    case 100 + OP_TRN:
    case 100 + OP_TRNE:
    case 100 + OP_TRNA:
    case 100 + OP_TRNN:
    case 100 + OP_TRZ:
    case 100 + OP_TRZE:
    case 100 + OP_TRZA:
    case 100 + OP_TRZN:
    case 100 + OP_TRC:
    case 100 + OP_TRCE:
    case 100 + OP_TRCA:
    case 100 + OP_TRCN:
    case 100 + OP_TRO:
    case 100 + OP_TROE:
    case 100 + OP_TROA:
    case 100 + OP_TRON:
    case 100 + OP_TLN:
    case 100 + OP_TLNE:
    case 100 + OP_TLNA:
    case 100 + OP_TLNN:
    case 100 + OP_TLZ:
    case 100 + OP_TLZE:
    case 100 + OP_TLZA:
    case 100 + OP_TLZN:
    case 100 + OP_TLC:
    case 100 + OP_TLCE:
    case 100 + OP_TLCA:
    case 100 + OP_TLCN:
    case 100 + OP_TLO:
    case 100 + OP_TLOE:
    case 100 + OP_TLOA:
    case 100 + OP_TLON:
    case 100 + OP_TDN:
    case 100 + OP_TDNE:
    case 100 + OP_TDNA:
    case 100 + OP_TDNN:
    case 100 + OP_TDZ:
    case 100 + OP_TDZE:
    case 100 + OP_TDZA:
    case 100 + OP_TDZN:
    case 100 + OP_TDC:
    case 100 + OP_TDCE:
    case 100 + OP_TDCA:
    case 100 + OP_TDCN:
    case 100 + OP_TDO:
    case 100 + OP_TDOE:
    case 100 + OP_TDOA:
    case 100 + OP_TDON:
    case 100 + OP_TSN:
    case 100 + OP_TSNE:
    case 100 + OP_TSNA:
    case 100 + OP_TSNN:
    case 100 + OP_TSZ:
    case 100 + OP_TSZE:
    case 100 + OP_TSZA:
    case 100 + OP_TSZN:
    case 100 + OP_TSC:
    case 100 + OP_TSCE:
    case 100 + OP_TSCA:
    case 100 + OP_TSCN:
    case 100 + OP_TSO:
    case 100 + OP_TSOE:
    case 100 + OP_TSOA:
    case 100 + OP_TSON:

/* Can I cheat like Juil can?  Not if Folken has anything to do with it... */
      /* Watch this.  All of these instructions have 4 steps.

         1.   Get the operand (what to test) in br.
         2.   Do the test.  Skip if need be.
         3.   Modify the operand, store the result.

       */
      switch (brx & 0711000000000LL)
	{

	case 0600000000000LL:
	  /*      printf("CPU: TR\n"); */
	  /* Test right */
	  br = do_memory_read (ac, 0);	/* Fetch */
	  arx = form_word (0, e_addr);	/* Op2 */
	  ar = form_word (0, br & e_addr);	/* Do the compare */
	  break;

	case 0601000000000LL:
	  /*              printf("CPU: TL\n"); */
	  /* Test left */
	  br = do_memory_read (ac, 0);	/* Fetch */
	  arx = form_word (e_addr, 0);	/* Op2 */
	  ar = form_word (get_lf_half (br) & e_addr, 0);
	  break;

	case 0610000000000LL:
	  /*              printf("CPU: TD\n"); */
	  /* Test direct */
	  br = do_memory_read (ac, 0);	/* Fetch */
	  arx = do_memory_read (e_addr, 0);	/* Op2 */
	  ar = br & arx;	/* Compare */
	  break;

	case 0611000000000LL:
	  /* printf("CPU: TS\n"); */
	  /* Test swapped */
	  br = do_memory_read (ac, 0);	/* Fetch */
	  ar = do_memory_read (e_addr, 0);
	  ar = form_word (get_rt_half (ar), get_lf_half (ar));
	  arx = ar;		/* Op2 */
	  ar = br & ar;		/* Compare */
	  break;

	default:
	  /* Dying hurts like hell. */
	  printf ("CPU: OOPS: UNKNOWN OPERAND IN TEST SWITCH 1\n");
	  goto do_halt;
	}

      switch (brx & 0006000000000LL)
	{

	case 000000000000LL:
	  /*      printf("CPU: (no skip)\n"); */
	  /* Don't skip */
	  break;

	case 0002000000000LL:
	  /*              printf("CPU: E\n"); */
	  /* Skip if all masked bits = 0 */
	  if (ar == 0)
	    {
	      DO_SKIP;
	    }
	  break;

	case 0004000000000LL:
	  /*              printf("CPU: A\n"); */
	  /* Skip always */
	  DO_SKIP;
	  break;

	case 0006000000000LL:
	  /*              printf("CPU: N %lo,,%lo\n",get_lf_half(ar),get_rt_half(ar)); */
	  /* Skip if not all masked bits = 0 */
	  if (ar != 0)
	    {
	      DO_SKIP;
	    }
	  break;

	default:
	  /* Koino otasuke ha Moon ni omakase */
	  /* Leave it to the Moon to aid in love */
	  printf ("CPU: OOPS: UNKNOWN OPERAND IN TEST SWITCH 2\n");
	  goto do_halt;
	}

      switch (brx & 0060000000000LL)
	{
	case 0000000000000LL:
	  /*      printf("CPU: N\n"); */
	  /* No mod */
	  break;

	case 0020000000000LL:
	  /*      printf("CPU: Z\n"); */
	  /* Zeroes */
	  /* ar is test results, br is ac, arx is op 2 */
	  ar = 1;
	  while (ar > 01000000000000LL)
	    {
	      /* This is odd. */
	      if ((br & (arx & ar)) == ar)
		{
		  /* This bit is set in E and AC */
		  br = br & (~ar);	/* Clear all but 
					   this one */
		}
	      ar = ar << 1;	/* Next */
	    }
	  do_memory_write (ac, br);	/* Write AC */
	  break;

	case 0040000000000LL:
	  /*      printf("CPU: C\n"); */
	  /* Complement */
	  /* ar is test results, br is AC, arx is op 2 */
	  ar = 1;
	  while (ar > 01000000000000LL)
	    {
	      /* This is odd. */
	      if ((br & (arx & ar)) == ar)
		{
		  /* This bit is set in E and AC */
		  br = br & (~ar);	/* Clear all but 
					   this one */
		}
	      else
		{
		  if ((arx & ar) == ar)
		    {
		      /* This is set in E but not AC */
		      br = br | ar;	/* Set it */
		    }
		}
	      ar = ar << 1;	/* Next */
	    }
	  do_memory_write (ac, br);	/* Write AC */
	  break;

	case 0060000000000LL:
	  /*      printf("CPU: O\n"); */
	  /* Ones */
	  br = br | arx;
	  do_memory_write (ac, br);	/* Write */
	  break;

	default:
	  /* Usagi no Ai! Gekkou Ginga wo Terasu */
	  /* Usagi's Love! The Moonlight illuminates the galaxy. */
	  /* Unfortunately, the story is over... :( :( */
	  printf ("CPU: OOPS: UNKNOWN OPERAND IN TEST SWITCH 3\n");
	  goto do_halt;
	}

      /* And at this point, we're done. */
      NXT_INST;

/* HALFWORD DATA TRANSMISSION */

    case 100 + OP_HLL:
    case 100 + OP_HLLI:
    case 100 + OP_HLLM:
    case 100 + OP_HLLS:
    case 100 + OP_HLLZ:
    case 100 + OP_HLLZI:
    case 100 + OP_HLLZM:
    case 100 + OP_HLLZS:
    case 100 + OP_HLLO:
    case 100 + OP_HLLOI:
    case 100 + OP_HLLOM:
    case 100 + OP_HLLOS:
    case 100 + OP_HLLE:
    case 100 + OP_HLLEI:
    case 100 + OP_HLLEM:
    case 100 + OP_HLLES:
    case 100 + OP_HRL:
    case 100 + OP_HRLI:
    case 100 + OP_HRLM:
    case 100 + OP_HRLS:
    case 100 + OP_HRLZ:
    case 100 + OP_HRLZI:
    case 100 + OP_HRLZM:
    case 100 + OP_HRLZS:
    case 100 + OP_HRLO:
    case 100 + OP_HRLOI:
    case 100 + OP_HRLOM:
    case 100 + OP_HRLOS:
    case 100 + OP_HRLE:
    case 100 + OP_HRLEI:
    case 100 + OP_HRLEM:
    case 100 + OP_HRLES:
    case 100 + OP_HRR:
    case 100 + OP_HRRI:
    case 100 + OP_HRRM:
    case 100 + OP_HRRS:
    case 100 + OP_HRRZ:
    case 100 + OP_HRRZI:
    case 100 + OP_HRRZM:
    case 100 + OP_HRRZS:
    case 100 + OP_HRRO:
    case 100 + OP_HRROI:
    case 100 + OP_HRROM:
    case 100 + OP_HRROS:
    case 100 + OP_HRRE:
    case 100 + OP_HRREI:
    case 100 + OP_HRREM:
    case 100 + OP_HRRES:
    case 100 + OP_HLR:
    case 100 + OP_HLRI:
    case 100 + OP_HLRM:
    case 100 + OP_HLRS:
    case 100 + OP_HLRZ:
    case 100 + OP_HLRZI:
    case 100 + OP_HLRZM:
    case 100 + OP_HLRZS:
    case 100 + OP_HLRO:
    case 100 + OP_HLROI:
    case 100 + OP_HLROM:
    case 100 + OP_HLROS:
    case 100 + OP_HLRE:
    case 100 + OP_HLREI:
    case 100 + OP_HLREM:
    case 100 + OP_HLRES:
/*      From Left clears bit 6, From Right sets bit 6.
   To Left clears bit 3, To Right sets bit 3.
   No mod, zeroes, ones, extend is determined by bits 4 and 5.
   Bits 7 and 8 determine the source data.      

   To do a halfword-move instruction:

   1.  Fetch the source.
   2.  Fetch the destination.
   3.  Modify the destination as needed.
   4.  Store the modified destination.

 */
      /* Fetch source to ar, dst to br */
      switch (arx & 0003000000000LL)
	{
	case 0000000000000LL:
	  /* Basic */
	  ar = do_memory_read (e_addr, 0);
	  br = do_memory_read (ac, 0);
	  break;
	case 0001000000000LL:
	  /* Immediate */
	  ar = form_word (0, e_addr);
	  br = do_memory_read (ac, 0);
	  /* CHECK FOR XHLLI CROCK HERE! */
	  if (cpu_section)
	    {
	      printf ("%%POSSIBLE XHLLI\n");
	      /* Possible XHLLI */
	      if (opc == 0501)
		{
		  printf ("%%IS XHLLI\n");
		  /* It is an XHLLI */
		  /* Is E an AC address? */
		  if ((e_addr & 0777777) > 020)
		    {
		      /* Section 1 and E to AC */
		      do_memory_write (ac, (01000000LL | (e_addr & 0777777)));
		    }
		  else
		    {
		      /* Full E to AC */
		      do_memory_write (ac, e_addr);
		    }
		  /* Done */
		  goto halfword_op_done;
		}
	      /* Not XHLLI */
	    }
	  break;
	case 0002000000000LL:
	  /* Memory */
	  ar = do_memory_read (ac, 0);
	  br = do_memory_read (e_addr, 0);
	  break;
	case 0003000000000LL:
	  /* Self */
	  ar = do_memory_read (e_addr, 0);
	  br = do_memory_read (e_addr, 0);
	  break;
	default:
	  /* Oh, shit. */
	  printf ("CPU: HALFWORD MOVE FAILURE 1\n");
	  goto do_halt;
	}

      /* Halfword being dealt with to brx */
      if (arx & 0004000000000LL)
	{
	  /* Right */
	  brx = get_rt_half (ar);
	}
      else
	{
	  /* Left */
	  brx = get_lf_half (br);
	}

      /* Modify br as needed */
      /* Now, modify further... */
      switch (arx & 0030000000000LL)
	{
	case 0000000000000LL:
	  /* Nothing */
	  if (arx & 0040000000000LL)
	    {
	      /* Right */
	      br = form_word (get_lf_half (br), brx);
	    }
	  else
	    {
	      /* Left */
	      br = form_word (brx, get_rt_half (br));
	    }
	  break;
	case 0010000000000LL:
	  /* Zeroes */
	  if (arx & 0040000000000LL)
	    {
	      /* Right */
	      br = form_word (brx, 0);
	    }
	  else
	    {
	      /* Left */
	      br = form_word (0, brx);
	    }
	  break;
	case 0020000000000LL:
	  /* Ones */
	  if (arx & 0040000000000LL)
	    {
	      /* Right */
	      br = form_word (brx, 777777);
	    }
	  else
	    {
	      /* Left */
	      br = form_word (777777, brx);
	    }
	  break;
	case 0030000000000LL:
	  /* Extend */
	  if (arx & 0040000000000LL)
	    {
	      /* Right */
	      if (brx & 400000)
		{
		  br = form_word (brx, 777777);
		}
	      else
		{
		  br = form_word (brx, 0);
		}
	    }
	  else
	    {
	      /* Left */
	      if (brx & 400000)
		{
		  br = form_word (777777, brx);
		}
	      else
		{
		  br = form_word (0, brx);
		}
	    }
	  break;
	default:
	  printf ("CPU: HALFWORD MOVE LOSSAGE 2\n");
	  goto do_halt;
	}
      /* Now, store br */
      switch (arx & 0003000000000LL)
	{
	case 0000000000000LL:
	  /* Basic */
	  do_memory_write (ac, br);
	  break;
	case 0001000000000LL:
	  /* Immediate */
	  do_memory_write (ac, br);
	  break;
	case 0002000000000LL:
	  /* Memory */
	  do_memory_write (e_addr, br);
	  break;
	case 0003000000000LL:
	  /* Self */
	  do_memory_write (e_addr, br);
	  if (ac)
	    {
	      do_memory_write (ac, br);
	    }
	  break;
	default:
	  /* Oh, shit. */
	  printf ("CPU: HALFWORD MOVE OOPS 3\n");
	  goto do_halt;
	}
      /* Done. */
    halfword_op_done:
      NXT_INST;

/* PROGRAM CONTROL */

    case 100 + OP_XCT:
      arx = do_memory_read (e_addr, 1);		/* Inst to ARX */
      brx = arx;
      /* Build instruction-based toys */
      ac = (arx & (0000740000000LL)) >> 23;
      id_bit = (arx & (0000020000000LL)) >> 22;
      id_ac = (arx & (0000017000000LL)) >> 18;
      inst_addr = arx & 0777777;
      micropc = 2;
      break;			/* Dispatch to XCT entry */
      /* The PC never gets updated this way, the instr in arx gets ran,
         and the CPU state isn't changed any, so nesting XCTs works */

    case 100 + OP_JFFO:
      /* Jump and find first one */
      br = do_memory_read (ac, 0);
      if (br == 0)
	{			/* Zero */
	  do_memory_write (ac + 1, 0);	/* Clobber AC+1 */
	  NXT_INST;		/* Continue */
	}
      else
	{
	  arx = 1;
	  brx = 0400000000000LL;
	  while (brx > 0)
	    {
	      /* Test for a one */
	      if ((br & brx) == brx)
		{
		  do_memory_write (ac + 1, arx);	/* Do this */
		  NXT_INST;	/* Continue */
		}
	      /* Nope. */
	      arx++;
	      brx = brx >> 1;
	    }
	  NXT_INST;
	}
      NXT_INST;

    case 100 + OP_JFCL:
      /* Jump on Flag and Clear */
      if ((ac & 1) && (pc & F_FOV))
	{
	  /* Floating Overflow */
	  pc = pc ^ F_FOV;
	  DO_JUMP;		/* Jump to E */
	}
      if ((ac & 2) && (pc & F_CRY1))
	{
	  /* Carry 1 */
	  pc = pc ^ F_CRY1;
	  DO_JUMP;
	}
      if ((ac & 4) && (pc & F_CRY0))
	{
	  /* Carry 0 */
	  pc = pc ^ F_CRY0;
	  DO_JUMP;
	}
      if ((ac & 8) && (pc & F_AROV))
	{
	  /* Arith Overflow */
	  pc = pc ^ F_AROV;
	  DO_JUMP;
	}
      NXT_INST;

    case 100 + OP_JRST:
      /* Jump and Restore, and some special tricks */
      switch (ac)
	{
	case 00:
	  /* Jump to E */
	  DO_JUMP;
	  break;
	case 01:
	  /* PORTAL */
	  printf ("CPU: PORTAL not implemented\n");
	  goto do_halt;
	  break;
	case 02:
	jrstf_entry:		/* JRSTF */
	  /* Restore flags from bits 0-12 of the final
	     word used in the effective address calculation. */
	  /* That word is stored in jrstf_ptr. */
	  if (jrstf_ptr & 0400000000000LL)
	    {
	      /* FOV or Previous Context Public if in
	         exec mode */
	      if (jrstf_ptr & 0010000000000LL)
		{
		  /* Saved in user mode */
		  pc = pc | F_AROV;	/* Set this */
		}
	      else
		{
		  /* Saved in exec mode */
		  /* Don't quite know what to
		     do with this yet... */
		  pc = pc | F_AROV;	/* Set this */
		}
	    }
	  else
	    {
	      /* Clear F_AROV */
	      pc = pc & (~F_AROV);
	    }
	  if (jrstf_ptr & 0200000000000LL)
	    {
	      /* CRY0 */
	      pc = pc | F_CRY0;
	    }
	  else
	    {
	      pc = pc & (~F_CRY0);
	    }
	  if (jrstf_ptr & 0100000000000LL)
	    {
	      /* CRY1 */
	      pc = pc | F_CRY1;
	    }
	  else
	    {
	      pc = pc & (~F_CRY1);
	    }
	  if (jrstf_ptr & 0040000000000LL)
	    {
	      /* FOV */
	      pc = pc | F_FOV;
	    }
	  else
	    {
	      pc = pc & (~F_FOV);
	    }
	  if (jrstf_ptr & 0020000000000LL)
	    {
	      /* FPD */
	      pc = pc | F_FPD;
	    }
	  else
	    {
	      pc = pc & (~F_FPD);
	    }
	  if (jrstf_ptr & 0010000000000LL)
	    {
	      /* USER */
	      /* Anyone can set this. */
	      pc = pc | F_USER;
	    }
	  else
	    {
	      /* Clearing USER? */
	      if (!(pc & F_USER))
		{
		  /* Only exec mode does this */
		  pc = pc & (~F_USER);
		}
	    }
	  if (jrstf_ptr & 0004000000000LL)
	    {
	      /* If we are in exec mode, this is
	         previous context user.  Otherwise,
	         user IO mode. */
	      if (!(pc & F_USER))
		{
		  /* Only exec can set this */
		  pc = pc | F_USER;
		}
	      /* Dunno what to do with this "previous
	         context user" thing. */
	    }
	  else
	    {
	      pc = pc & (~F_IOT);
	    }			/* Anyone can clear this */
	  if (jrstf_ptr & 0002000000000LL)
	    {
	      /* Public */
	      /* Anyone can set it? */
	      pc = pc | F_PUBL;
	    }
	  else
	    {
	      if (!(pc & F_PUBL))
		{
		  pc = pc & (~F_PUBL);
		}
	    }
	  /* Public can't clear public. */
	  if (jrstf_ptr & 0001000000000LL)
	    {
	      /* Address failure inhibit. */
	      /* What the heck is this? */
	      pc = pc | F_AFI;
	    }
	  else
	    {
	      pc = pc & (~F_AFI);
	    }
	  if (jrstf_ptr & 0000400000000LL)
	    {
	      /* TRAP 2 */
	      pc = pc | F_TRAP2;
	    }
	  else
	    {
	      pc = pc & (~F_TRAP2);
	    }
	  if (jrstf_ptr & 0000200000000LL)
	    {
	      /* TRAP 1 */
	      pc = pc | F_TRAP1;
	    }
	  else
	    {
	      pc = pc & (~F_TRAP1);
	    }
	  if (jrstf_ptr & 0000100000000LL)
	    {
	      /* FLOATING UNDERFLOW */
	      pc = pc | F_FXU;
	    }
	  else
	    {
	      pc = pc & (~F_FXU);
	    }
	  if (jrstf_ptr & 0000040000000LL)
	    {
	      /* DIVIDE CHECK */
	      pc = pc | F_DCK;
	    }
	  else
	    {
	      pc = pc & (~F_DCK);
	    }
	  DO_JUMP;		/* Do jump to E_ADDR */
	  break;
	case 04:
	  /* HALT */
	  /* Only exec mode can do this */
	  if (pc & F_USER)
	    {
	      printf ("CPU: Erm, why's some luser trying to halt me?\n");
	      /* I should make an MUUO here! */
	    }
	  else
	    {
	      printf ("%%CPU: HALT INSTRUCTION\n");
	      DO_JUMP;
	      goto do_halt;
	    }
	  break;
	case 05:
	  /* XJRSTF */
	xjrstf_entry:
	  /* JRSTF, but with extended toys. */
	  /* Restore flags-pc doubleword at E */
	  br = do_memory_read (e_addr, 0);
	  brx = do_memory_read (e_addr + 1, 0);
	xjrstf_redo:		/* Restore flags */
	  if (br & 0400000000000LL)
	    {
	      /* FOV or Previous Context Public if in
	         exec mode */
	      if (br & 0010000000000LL)
		{
		  /* Saved in user mode */
		  pc = pc | F_AROV;	/* Set this */
		}
	      else
		{
		  /* Saved in exec mode */
		  /* Don't quite know what to
		     do with this yet... */
		  pc = pc | F_AROV;	/* Set this */
		}
	    }
	  else
	    {
	      /* Clear F_AROV */
	      pc = pc & (~F_AROV);
	    }
	  if (br & 0200000000000LL)
	    {
	      /* CRY0 */
	      pc = pc | F_CRY0;
	    }
	  else
	    {
	      pc = pc & (~F_CRY0);
	    }
	  if (br & 0100000000000LL)
	    {
	      /* CRY1 */
	      pc = pc | F_CRY1;
	    }
	  else
	    {
	      pc = pc & (~F_CRY1);
	    }
	  if (br & 0040000000000LL)
	    {
	      /* FOV */
	      pc = pc | F_FOV;
	    }
	  else
	    {
	      pc = pc & (~F_FOV);
	    }
	  if (br & 0020000000000LL)
	    {
	      /* FPD */
	      pc = pc | F_FPD;
	    }
	  else
	    {
	      pc = pc & (~F_FPD);
	    }
	  if (br & 0010000000000LL)
	    {
	      /* USER */
	      /* Anyone can set this. */
	      pc = pc | F_USER;
	    }
	  else
	    {
	      /* Clearing USER? */
	      if (!(pc & F_USER))
		{
		  /* Only exec mode does this */
		  pc = pc & (~F_USER);
		}
	    }
	  if (br & 0004000000000LL)
	    {
	      /* If we are in exec mode, this is
	         previous context user.  Otherwise,
	         user IO mode. */
	      if (!(pc & F_USER))
		{
		  /* Only exec can set this */
		  pc = pc | F_USER;
		}
	      /* Dunno what to do with this "previous
	         context user" thing. */
	    }
	  else
	    {
	      pc = pc & (~F_IOT);
	    }			/* Anyone can clear this */
	  if (br & 0002000000000LL)
	    {
	      /* Public */
	      /* Anyone can set it? */
	      pc = pc | F_PUBL;
	    }
	  else
	    {
	      if (!(pc & F_PUBL))
		{
		  pc = pc & (~F_PUBL);
		}
	    }
	  /* Public can't clear public. */
	  if (br & 0001000000000LL)
	    {
	      /* Address failure inhibit. */
	      /* What the heck is this? */
	      pc = pc | F_AFI;
	    }
	  else
	    {
	      pc = pc & (~F_AFI);
	    }
	  if (br & 0000400000000LL)
	    {
	      /* TRAP 2 */
	      pc = pc | F_TRAP2;
	    }
	  else
	    {
	      pc = pc & (~F_TRAP2);
	    }
	  if (br & 0000200000000LL)
	    {
	      /* TRAP 1 */
	      pc = pc | F_TRAP1;
	    }
	  else
	    {
	      pc = pc & (~F_TRAP1);
	    }
	  if (br & 0000100000000LL)
	    {
	      /* FLOATING UNDERFLOW */
	      pc = pc | F_FXU;
	    }
	  else
	    {
	      pc = pc & (~F_FXU);
	    }
	  if (br & 0000040000000LL)
	    {
	      /* DIVIDE CHECK */
	      pc = pc | F_DCK;
	    }
	  else
	    {
	      pc = pc & (~F_DCK);
	    }
	  /* Frob PC */
	  cpu_section = (brx & 0007777000000LL) >> 18;
	  e_addr = brx & 0007777777777LL;
	  DO_JUMP;

	  /* Odd XPCW kludge */
	  if (opc == (100 + OP_JRST) && ac == 07 && pi_cycle == 1)
	    {
	      /* Blindly load mode, ignoring restrictions */
	      if (br & 0010000000000LL)
		{
		  /* Set/clear user mode */
		  pc = pc & (~F_USER);
		}
	      else
		{
		  pc = pc | F_USER;
		}
	      if (br & 0002000000000LL)
		{
		  /* Set/clear PUBL */
		  pc = pc & (~F_PUBL);
		}
	      else
		{
		  pc = pc | F_PUBL;
		}
	      /* Kludge done */
	    }
	  NXT_INST;
	  /* Done */
	  break;
	case 06:
	  /* XJEN */
	  /* Dismiss highest PI, then XJRSTF */
	  br = 0;
	  while (br <= 7)
	    {
	      if (pi_req[br] != 0)
		{
		  pi_req[br] = 0;
		  pi_pdn[br] = 0;
		  pi_fcn[br] = 0;
		  if (pi_cycle)
		    {
		      /* Clear this interrupt */
		      pi_undo_microsave ();
		    }
		  /* XJRSTF */
		  goto xjrstf_entry;

		}
	      br++;
	    }

	  break;
	case 07:
	  /* XPCW */
	  /* Save the PC and flags in a PC-flag-doubleword
	     at E and E+1.  Then restore the PC and flags
	     (including section bits) from a PC and flags
	     doubleword at E+2 and E+3. */

	  br = 0;

	  if (pc & F_USER)
	    {
	      /* Luser mode, F_AROV */
	      if (pc & F_AROV)
		{
		  br = br | 0400000000000LL;
		}
	    }
	  else
	    {
	      /* PREVIOUS CONTEXT PUBLIC? */
	    }
	  if (pc & F_CRY0)
	    {
	      br = br | 0200000000000LL;
	    }
	  if (pc & F_CRY1)
	    {
	      br = br | 0100000000000LL;
	    }
	  if (pc & F_FOV)
	    {
	      br = br | 0040000000000LL;
	    }
	  if (pc & F_FPD)
	    {
	      br = br | 0020000000000LL;
	    }
	  if (pc & F_USER)
	    {
	      br = br | 0010000000000LL;
	    }
	  if (pc & F_USER)
	    {
	      /* User IO? */
	      if (pc & F_IOT)
		{
		  br = br | 0004000000000LL;
		}
	    }
	  else
	    {
	      /* PREVIOUS CONTEXT USER? */
	    }
	  if (pc & F_PUBL)
	    {
	      br = br | 0002000000000LL;
	    }
	  if (pc & F_AFI)
	    {
	      br = br | 0001000000000LL;
	    }
	  if (pc & F_TRAP2)
	    {
	      br = br | 0000400000000LL;
	    }
	  if (pc & F_TRAP1)
	    {
	      br = br | 0000200000000LL;
	    }
	  if (pc & F_FXU)
	    {
	      br = br | 0000100000000LL;
	    }
	  if (pc & F_DCK)
	    {
	      br = br | 0000040000000LL;
	    }
	  /* Save flags done */
	  do_memory_write (ac, br);	/* STORE */
	  brx = 0;
	  brx = ((pc & 0777777) | (cpu_section << 18));
	  do_memory_write (ac + 1, brx);
	  /* Store PC done */
	  br = do_memory_read (ac + 2, brx);
	  brx = do_memory_read (ac + 3, brx);
	  goto xjrstf_redo;	/* CHEAT */

	  break;
	case 010:
	  /* Dismiss current interrupt */
	  pi_fcn[pi_us_holding_pi] = 0;
	  pi_pdn[pi_us_holding_pi] = 0;
	  pi_req[pi_us_holding_pi] = 0;

	  pi_undo_microsave ();

	  break;
	case 012:
	  /* JEN */
	  /* Dismiss the interrupt, and do a JRSTF. */

	  pi_fcn[pi_us_holding_pi] = 0;
	  pi_pdn[pi_us_holding_pi] = 0;

	  pi_undo_microsave ();

	  goto jrstf_entry;

	  break;
	case 014:
	  /* SFM */
	  /* Save flags and PC at E.  Include section. */

	  br = 0;

	  if (pc & F_USER)
	    {
	      /* Luser mode, F_AROV */
	      if (pc & F_AROV)
		{
		  br = br | 0400000000000LL;
		}
	    }
	  else
	    {
	      /* PREVIOUS CONTEXT PUBLIC? */
	    }
	  if (pc & F_CRY0)
	    {
	      br = br | 0200000000000LL;
	    }
	  if (pc & F_CRY1)
	    {
	      br = br | 0100000000000LL;
	    }
	  if (pc & F_FOV)
	    {
	      br = br | 0040000000000LL;
	    }
	  if (pc & F_FPD)
	    {
	      br = br | 0020000000000LL;
	    }
	  if (pc & F_USER)
	    {
	      br = br | 0010000000000LL;
	    }
	  if (pc & F_USER)
	    {
	      /* User IO? */
	      if (pc & F_IOT)
		{
		  br = br | 0004000000000LL;
		}
	    }
	  else
	    {
	      /* PREVIOUS CONTEXT USER? */
	    }
	  if (pc & F_PUBL)
	    {
	      br = br | 0002000000000LL;
	    }
	  if (pc & F_AFI)
	    {
	      br = br | 0001000000000LL;
	    }
	  if (pc & F_TRAP2)
	    {
	      br = br | 0000400000000LL;
	    }
	  if (pc & F_TRAP1)
	    {
	      br = br | 0000200000000LL;
	    }
	  if (pc & F_FXU)
	    {
	      br = br | 0000100000000LL;
	    }
	  if (pc & F_DCK)
	    {
	      br = br | 0000040000000LL;
	    }
	  /* Save flags done */
	  /* If we're in exec mode, save the previous
	     context section.  This is not implemented... */
	  if (pc & F_USER)
	    {
	      br = br | (pc & 0777777LL);
	    }
	  else
	    {
	      printf ("CPU: SFM in EXEC mode acts like USER MODE\n");
	      br = br | (pc & 0777777LL);
	    }
	  do_memory_write (e_addr, br);
	  NXT_INST;

	  break;
	default:
	  /* I should do something here. */
	  break;
	}
      NXT_INST;

    case 100 + OP_JSR:
      /* Jump to Subroutine. Save PC at E, jump to E+1 */
      do_memory_write (e_addr, pc);
      e_addr++;
      DO_JUMP;
      if (pi_cycle)
	{
	  /* Go to kernel mode */
	  pc = pc & (~F_USER);
	  pc = pc & (~F_PUBL);
	}

      NXT_INST;

    case 100 + OP_JSP:
      /* Jump and Save PC.  PC to AC, Jump to E */
      do_memory_write (ac, pc);
      DO_JUMP;
      NXT_INST;

    case 100 + OP_JSA:
      /* Jump and Save AC.  AC > E, E rt > AC lf, PC rt > AC rt */
      do_memory_write (e_addr, do_memory_read (ac, 0));
      do_memory_write (ac, form_word (do_memory_read (e_addr, 0), pc));
      e_addr++;
      DO_JUMP;
      NXT_INST;

    case 100 + OP_JRA:
      /* Jump and Restore AC.  (AC lf)>AC, Jump */
      do_memory_write (ac, get_lf_half (do_memory_read (ac, 0)));
      DO_JUMP;
      NXT_INST;

    case 100 + OP_PUSH:
      /* Bump both halves of AC */
      br = do_memory_read (ac, 0);
      do_memory_write (ac, form_word (get_lf_half (br) + 1, get_rt_half (br) + 1));
      /* Store */
      do_memory_write (get_rt_half (br) + 1, do_memory_read (e_addr, 0));
      NXT_INST;

    case 100 + OP_PUSHJ:
      /* Bump both halves of AC */
      br = do_memory_read (ac, 0);
      br = form_word (get_lf_half (br) + 1, get_rt_half (br) + 1);
      do_memory_write (ac, br);
      /* Store */
      do_memory_write (br & 0777777, pc);	/* PC TO (AC) */
      DO_JUMP;
      NXT_INST;

    case 100 + OP_POP:
      br = do_memory_read (ac, 0);
      do_memory_write (get_rt_half (br), do_memory_read (e_addr, 0));
      br = form_word (get_lf_half (br) - 1, get_rt_half (br) - 1);
      do_memory_write (ac, br);
      NXT_INST;

    case 100 + OP_POPJ:
      br = do_memory_read (ac, 0);	/* br is now AC */
      br = get_rt_half (br);	/* br is now AC right */
      e_addr = do_memory_read (br, 0) & 0777777LL;	/* E now E */
      br = form_word ((get_lf_half (br)) - 1, (get_rt_half (br)) - 1);
      do_memory_write (ac, br);
      DO_JUMP;
      NXT_INST;

    case 100 + OP_ADJSP:
      /* Adjust stack pointer */
      br = do_memory_read (ac, 0);
      if (e_addr & 0400000)
	{
	  /* Subtract */
	  br = form_word ((get_lf_half (br) - (e_addr & 0377777)), (get_rt_half (br) - (e_addr & 0377777)));
	}
      else
	{
	  /* Add */
	  br = form_word ((get_lf_half (br) + (e_addr & 0377777)), (get_rt_half (br) + (e_addr & 0377777)));
	}
      /* Store */
      do_memory_write (ac, br);
      NXT_INST;

    case 100 + OP_LDB:
      /* E to to AC rt. */
      /* br=calc_e_addr(do_memory_read(e_addr,0)); */
      br = e_addr;
/*
   printf("LDB pointer addr = %lo\n",(unsigned long)br);
 */
      /* BR has address of byte pointer now. */
      ar = do_memory_read (br, 0);	/* Fetch word */
      bptr_pos = (ar & 0770000000000LL) >> 30;	/* Position */
      bptr_size = (ar & 0007700000000LL) >> 24;		/* Size */
/*
   printf("LDB pos = %lo, size = %lo\n",bptr_pos,bptr_size);
 */
      /* Now, build the mask */
      brx = (bptr_size - 1);
      br = 01LL;
      if (bptr_size == 0)
	{
	  brx = 0;
	  br = 0;
	}
      while (brx > 0)
	{
	  br = br << 1;
	  br = br | 01LL;
	  brx = brx - 1;
	}
/*
   printf("LDB mask = %lo,,%lo\n",get_lf_half(br),get_rt_half(br));
 */
      /* BR is now the mask */

      /* Move BRX into position */
      /* brx=brx>>(bptr_pos*bptr_size); */

      /* Get the byte */
      /* AR has the pointer word. */
      ar = calc_e_addr (ar);
/*
   printf("LDB: Data at %lo\n",(unsigned long)ar);
 */
      /* AR now has addr of data word */
      ar = do_memory_read (ar, 0);
      /* AR is now the data word */
/*
   printf("LDB data = %lo,,%lo\n",get_lf_half(ar),get_rt_half(ar));
 */
      ar = br & ar;

      /* Fix it's position */
      /* ar=(br>>(bptr_pos*bptr_size)); */
      /* Store it in AC */
      do_memory_write (ac, ar);
/*
   printf("LDB output = %lo,,%lo\n",get_lf_half(ar),get_rt_half(ar));
 */
      NXT_INST;

    case 100 + OP_DPB:
      /* Right S bits of AC to byte descibed at E. */
      br = calc_e_addr (do_memory_read (ac, 0));
      /* BR now has addr of pointer word. */

      ar = do_memory_read (br, 0);	/* Fetch word */
      bptr_pos = (ar & 0770000000000LL) >> 30;	/* Position */
      bptr_size = (ar & 0007700000000LL) >> 24;		/* Size */

      /* Now, build the mask */
      brx = (bptr_size - 1);
      br = 01LL;
      if (bptr_size == 0)
	{
	  brx = 0;
	  br = 0;
	}
      while (brx > 0)
	{
	  br = br << 1;
	  br = br | 01LL;
	  brx = brx - 1;
	}

      /* AR is now the pointer word.
         BR is the mask, not moved into position.
         BRX is scratch.      */
      /* Get source into BRX */
      ar = calc_e_addr (ar);

      /* AR is now addr of the data word */
      brx = do_memory_read (ar, 0);

      /* Now, clear the uneeded bits in BRX */
      brx = (brx & (~br));

      /* Move the source word into position, dump it. */
      br = do_memory_read (ac, 0);

      /* BR is now the source.  Source to bit 0. */
      br = br << (bptr_pos);

      /* Fix the position */
      br = br >> (bptr_size * bptr_pos);

      /* br is now the data, in the right position. */
      /* Put br in BRX */
      brx = brx | br;

      /* Store BRX */
      do_memory_write (ar, brx);

      /* Done */
      NXT_INST;

    case 100 + OP_IBP:
      /* Increment byte pointer */
      if (ac)
	{
	  goto op_adjbp;
	}			/* Ick. */

      br = e_addr;

      /* BR has address of byte pointer now. */

      ar = do_memory_read (br, 0);

      parse_byte_pointer (ar);

      if (bptr_size > bptr_pos)
	{
	  bptr_pos = (036 - bptr_size);		/* Leftmost byte */
	  bptr_loc++;		/* Bump this */
	}
      else
	{
	  bptr_pos = bptr_pos - bptr_size;
	}

      /* form new pointer */
      ar = build_byte_pointer ();

      /* Store new pointer */
      do_memory_write (br, ar);

      NXT_INST;			/* NEXT! */
    op_adjbp:
      /* ADJust Byte Pointer */
      /* This is gross and I don't wanna deal with it now. */
      printf ("CPU: OOPS: ADJBP isn't done.  Halting\n");
      goto do_halt;

    case 100 + OP_ILDB:
      /* Increment Pointer and Load Byte */
      br = e_addr;

      /* BR has address of byte pointer now. */

      ar = do_memory_read (br, 0);
/*      printf("ILDB e_addr = %lo\n",e_addr);
   printf("ILDB preptr = %lo,,%lo\n",get_lf_half(ar),get_rt_half(ar));
 */ parse_byte_pointer (ar);

      if (bptr_size > bptr_pos)
	{
	  bptr_pos = (036 - bptr_size);		/* Leftmost byte */
	  bptr_loc++;		/* Bump this */
	}
      else
	{
	  bptr_pos = bptr_pos - bptr_size;
	}

      /* form new pointer */
      ar = build_byte_pointer ();

      /* Store new pointer */
      do_memory_write (br, ar);

/*      printf("ILDB newptr = %lo,,%lo\n",get_lf_half(ar),get_rt_half(ar));
   printf("ILDB pos = %lo, size = %lo\n",bptr_pos,bptr_size);
 */
      /* Now, build the mask */
      brx = (bptr_size - 1);
      br = 01LL;
      if (bptr_size == 0)
	{
	  brx = 0;
	  br = 0;
	}
      while (brx > 0)
	{
	  br = br << 1;
	  br = br | 01LL;
	  brx = brx - 1;
	}

/*      printf("ILDB mask = %lo,,%lo\n",get_lf_half(br),get_rt_half(br));
 */
      /* BR is now the mask */

      /* Move BRX into position */
      /* brx=brx>>(bptr_pos*bptr_size); */

      /* Get the byte */
      /* AR has the pointer word. */
      ar = calc_e_addr (ar);

/*      printf("ILDB: Data at %lo\n",(unsigned long)ar);
 */
      /* AR now has addr of data word */
      ar = do_memory_read (ar, 0);
      /* AR is now the data word */

/*      printf("ILDB data = %lo,,%lo\n",get_lf_half(ar),get_rt_half(ar));
 */
      ar = br & ar;

      /* Fix it's position */
      /* ar=(br>>(bptr_pos*bptr_size)); */
      /* Store it in AC */
      do_memory_write (ac, ar);

/*      printf("ILDB output = %lo,,%lo\n",get_lf_half(ar),get_rt_half(ar));
 */
      NXT_INST;

    case 100 + OP_IDPB:
      /* Increment pointer and DePosit Byte */
      br = e_addr;
      /* BR now has addr of pointer word. */
      ar = do_memory_read (br, 0);	/* Fetch word */

      parse_byte_pointer (ar);

      if (bptr_size > bptr_pos)
	{
	  bptr_pos = (036 - bptr_size);		/* Leftmost byte */
	  bptr_loc++;		/* Bump this */
	}
      else
	{
	  bptr_pos = bptr_pos - bptr_size;
	}

      /* form new pointer */
      ar = build_byte_pointer ();

      /* Store new pointer */
      do_memory_write (br, ar);

      ar = do_memory_read (br, 0);	/* Fetch word */
      bptr_pos = (ar & 0770000000000LL) >> 30;	/* Position */
      bptr_size = (ar & 0007700000000LL) >> 24;		/* Size */

      /* Now, build the mask */
      brx = (bptr_size - 1);
      br = 01LL;
      if (bptr_size == 0)
	{
	  brx = 0;
	  br = 0;
	}
      while (brx > 0)
	{
	  br = br << 1;
	  br = br | 01LL;
	  brx = brx - 1;
	}

      /* AR is now the pointer word.
         BR is the mask, not moved into position.
         BRX is scratch.      */
      /* Get source into BRX */
      ar = calc_e_addr (ar);

      /* AR is now addr of the data word */
      brx = do_memory_read (ar, 0);

      /* Now, clear the uneeded bits in BRX */
      brx = (brx & (~br));

      /* Move the source word into position, dump it. */
      br = do_memory_read (ac, 0);

      /* BR is now the source.  Source to bit 0. */
      br = br << (bptr_pos);

      /* Fix the position */
      br = br >> (bptr_size * bptr_pos);

      /* br is now the data, in the right position. */
      /* Put br in BRX */
      brx = brx | br;

      /* Store BRX */
      do_memory_write (ar, brx);

      /* Done */

      NXT_INST;

    case 100 + OP_IO700:
    case 100 + OP_IO701:
    case 100 + OP_IO702:
    case 100 + OP_IO703:
    case 100 + OP_IO704:
    case 100 + OP_IO705:
    case 100 + OP_IO706:
    case 100 + OP_IO707:
    case 100 + OP_IO710:
    case 100 + OP_IO711:
    case 100 + OP_IO712:
    case 100 + OP_IO713:
    case 100 + OP_IO714:
    case 100 + OP_IO715:
    case 100 + OP_IO716:
    case 100 + OP_IO717:
    case 100 + OP_IO720:
    case 100 + OP_IO721:
    case 100 + OP_IO722:
    case 100 + OP_IO723:
    case 100 + OP_IO724:
    case 100 + OP_IO725:
    case 100 + OP_IO726:
    case 100 + OP_IO727:
    case 100 + OP_IO730:
    case 100 + OP_IO731:
    case 100 + OP_IO732:
    case 100 + OP_IO733:
    case 100 + OP_IO734:
    case 100 + OP_IO735:
    case 100 + OP_IO736:
    case 100 + OP_IO737:
    case 100 + OP_IO740:
    case 100 + OP_IO741:
    case 100 + OP_IO742:
    case 100 + OP_IO743:
    case 100 + OP_IO744:
    case 100 + OP_IO745:
    case 100 + OP_IO746:
    case 100 + OP_IO747:
    case 100 + OP_IO750:
    case 100 + OP_IO751:
    case 100 + OP_IO752:
    case 100 + OP_IO753:
    case 100 + OP_IO754:
    case 100 + OP_IO755:
    case 100 + OP_IO756:
    case 100 + OP_IO757:
    case 100 + OP_IO760:
    case 100 + OP_IO761:
    case 100 + OP_IO762:
    case 100 + OP_IO763:
    case 100 + OP_IO764:
    case 100 + OP_IO765:
    case 100 + OP_IO766:
    case 100 + OP_IO767:
    case 100 + OP_IO770:
    case 100 + OP_IO771:
    case 100 + OP_IO772:
    case 100 + OP_IO773:
    case 100 + OP_IO774:
    case 100 + OP_IO775:
    case 100 + OP_IO776:
    case 100 + OP_IO777:
/* I/O HANDLER */
      io_dev_nr = (brx & 0077400000000LL) >> 27;
      switch (brx & 0700340000000LL)
	{
	case 0700200000000LL:	/* CONO TRIGGER! ^_^ */
	  /* CONO */
	  switch (io_dev_nr)
	    {
	    case 04:		/* PI */
	      cono_pi ();
	      break;
	    case 010:		/* PAG */
	      cono_pag ();
	      break;
	    case 020:		/* DTE20 */
	      cono_dte ();
	      break;
	    }
	  break;
	case 0700240000000LL:
	  /* CONI */
	  switch (io_dev_nr)
	    {
	    case 04:		/* PI */
	      coni_pi ();
	      break;
	    case 010:		/* PAG */
	      coni_pag ();
	      break;
	    case 020:		/* DTE20 */
	      coni_dte ();
	      break;
	    }
	  break;
	case 0700140000000LL:
	  /* DATAO */
	  switch (io_dev_nr)
	    {
	    case 010:		/* PAG */
	      datao_pag ();
	      break;
	    case 020:		/* DTE20 */
	      datao_dte ();
	      break;
	    }
	  break;
	case 0700040000000LL:
	  /* DATAI */
	  switch (io_dev_nr)
	    {
	    case 010:		/* PAG */
	      datai_pag ();
	      break;
	    }
	  break;
	case 0700300000000LL:
	  /* CONSZ */
	  switch (io_dev_nr)
	    {

	    }
	  break;
	case 0700340000000LL:
	  /* CONSO */
	  switch (io_dev_nr)
	    {

	    }
	  break;
	case 0700100000000LL:
	  /* BLKO */
	  if (pi_cycle)
	    {
	      /* If pointer count is nonzero, dismiss
	         the interrupt (restore microstate) */
	      /* If code is nonzero, exec code in
	         second interrupt location. */
	      if (get_lf_half (do_memory_read (e_addr, 0)) == 0777777)
		{
		  /* Zero */
		  /* Crock an XCT of EPT+41+2*PI */
		  vma = pg_ept_page << 9;
		  vma = vma + (041 + (pi_us_holding_pi * 2));
		  arx = exa_word (vma);
		  brx = arx;
		  /* Build instruction-based toys */
		  ac = (arx & (0000740000000LL)) >> 23;
		  id_bit = (arx & (0000020000000LL)) >> 22;
		  id_ac = (arx & (0000017000000LL)) >> 18;
		  inst_addr = arx & 0777777;
		  micropc = 2;
		  break;	/* Dispatch to XCT entry */
		}
	      else
		{
		  /* Restore */
		  pi_fcn[pi_us_holding_pi] = 0;
		  pi_pdn[pi_us_holding_pi] = 0;
		  pi_req[pi_us_holding_pi] = 0;
		  pi_undo_microsave ();
		}
	    }
	  switch (io_dev_nr)
	    {
	    case 00:		/* APRID */
	      apr_blko ();
	      break;
	    case 010:
	      blko_pag ();
	      break;
	    }
	  break;
	case 0700000000000LL:
	  /* BLKI */
	  if (pi_cycle)
	    {
	      /* If pointer count is nonzero, dismiss
	         the interrupt (restore microstate) */
	      /* If code is nonzero, exec code in
	         second interrupt location. */
	      if (get_lf_half (do_memory_read (e_addr, 0)) == 0777777)
		{
		  /* Zero */
		  /* Crock an XCT of EPT+41+2*PI */
		  vma = pg_ept_page << 9;
		  vma = vma + (041 + (pi_us_holding_pi * 2));
		  arx = exa_word (vma);
		  brx = arx;
		  /* Build instruction-based toys */
		  ac = (arx & (0000740000000LL)) >> 23;
		  id_bit = (arx & (0000020000000LL)) >> 22;
		  id_ac = (arx & (0000017000000LL)) >> 18;
		  inst_addr = arx & 0777777;
		  micropc = 2;
		  break;	/* Dispatch to XCT entry */
		}
	      else
		{
		  /* Restore */
		  pi_fcn[pi_us_holding_pi] = 0;
		  pi_pdn[pi_us_holding_pi] = 0;
		  pi_req[pi_us_holding_pi] = 0;
		  pi_undo_microsave ();
		}
	    }
	  switch (io_dev_nr)
	    {

	    }
	  break;
	}
      NXT_INST;

/* LAST INSTR - This comment is here do you can just seek to LAST INSTR with
   your editor to find a spot to insert new instructions.  Make sure it's
   after the last instruction! */

    default:
      /* We interrupt this program to annoy you and generally harass you. */
      printf ("CPU: UNDEFINED MICROPC %li\n", micropc);
      micropc = 0;
      if (micropc == 100 + opc)
	{
	  printf ("CPU: UNDEFINED INSTRUCTION\n");
	}
      goto do_halt;
      break;
    }
  return (0);
do_halt:
  run = 0;
/* Later on we'll print crap here. */
  printf ("%%DECSYSTEM-10 NOT RUNNING\n");
  printf ("CPU: %s %lo %lo | PC %lo,,%lo\n", op_str[opc], ac, (unsigned long) e_addr, get_lf_half (pc), get_rt_half (pc));
  printf ("%%CONSOLE MODE\n");
/* NEED TO TURN ON ECHO HERE! */
  cons_set_tty_echo ();
  consolemode = 2;
  return (0);
}

unsigned long long 
do_memory_read (unsigned long addr, int fetch_flag)
{
/* This is called when the ebox requests a read from the mbox. */

/* NOTE: On global pointers and such, the section bits of addr
   will be set.  That means do global addressing.  If said bits are zero,
   the refrence is local.  If we're in section zero, everything is local
   mode.

   But then again, this is broken when we're not in section zero and wanting to
   store in section zero...  How do I determine that?

   The only way to get to section 0 from a nonzero section is with an EFIW 
   format indirect word with bits 6-17 are 0.  Maybe I can trap on this?

   Assume I did.  In that case, I have a flag telling me an EFIW format 
   indirect word happened, but no idea what it happened to...

   Maybe I could make the calc_e_addr function and friends return a word,
   including section bits, and deal with them all that way?  That would make 
   sense, except a lot of stuff that fetches based on PC and such would have
   to be hacked...  This makes the most sense though.

 */

/* Deal with the pager to get the physical addr */
/* Check for AC refrence */
  if ((addr & 0777777) < 020)
    {
      /* AC REFRENCE 
         printf("CPU: READ %lo,,%lo FROM 
         %lo\n",get_lf_half(fm[pg_fm_block][addr&0777777]),get_rt_half(fm[pg_fm_block][addr&077777]),addr); */
      return (fm[pg_fm_block][addr & 0777777]);
    }

  if (pg_pager_active)
    {
      addr = pg_get_pma (addr);
    }

/* Deal with caching */

/* Return the data at that address 
   printf("CPU: READ %lo,,%lo FROM 
   %lo\n",get_lf_half(memory[addr]),get_rt_half(memory[addr]),addr);  */

  if (addr > MEMORY_SIZE)
    {
      printf ("%%CPU: Umm, you can't read past the end of memory!\n");
      printf ("%%CPU: %s %lo %lo | PC %lo,,%lo | uPC %lo\n", op_str[opc], ac, (unsigned long) e_addr, get_lf_half (pc), get_rt_half (pc), micropc);
      return (0);
    }

  return (memory[addr]);

}

int 
do_memory_write (unsigned long addr, unsigned long long data)
{
/* This is called when the ebox requests a read from the mbox. */

/* Deal with the pager to get the physical addr */
/* Check for AC refrence */
  if ((addr & 0777777) < 020)
    {
      /* AC REFRENCE */
      fm[pg_fm_block][addr & 0777777] = data;
/* printf("CPU: WROTE %lo,,%lo AT 
   %lo\n",get_lf_half(data),get_rt_half(data),addr); */
      return (0);
    }


  if (pg_pager_active)
    {
      addr = pg_get_pma (addr);
    }

/* Deal with caching */

/* Return the data at that address 
   printf("CPU: WROTE %lo,,%lo AT 
   %lo\n",get_lf_half(data),get_rt_half(data),addr); */

  if (addr > MEMORY_SIZE)
    {
      printf ("%%CPU: Umm, you can't write past the end of memory!\n");
      printf ("%%CPU: %s %lo %lo | PC %lo,,%lo | uPC %lo\n", op_str[opc], ac, (unsigned long) e_addr, get_lf_half (pc), get_rt_half (pc), micropc);
      return (0);
    }

  memory[addr] = data;
  return (0);

}

unsigned long 
calc_e_addr (unsigned long long data)
{

  unsigned long long scratch;
  unsigned long eaddr;
  unsigned long eac, eid_bit, eid_ac, einst_addr;

ecalc_start:

  /* Build instruction-based toys */
  eac = (data & (0000740000000LL)) >> 23;
  eid_bit = (data & (0000020000000LL)) >> 22;
  eid_ac = (data & (0000017000000LL)) >> 18;
  einst_addr = data & 0777777;

/* This is being rewritten per revision 5 of the Extended Addressing memo
   by Mike Uhler. */

/* Right now, I have an instruction word or similarly formatted data in
   data.   I need to output a full 22-bit address, including section bits,
   for use by the memory-shuffling toys. */

/* First, are we indirecting? */

  eaddr = einst_addr;		/* Just to start with */

  if (eid_ac != 0)
    {
      if (inst_trace)
	{
	  printf ("%%EACALC: INDEXING WITH %lo\n", eid_ac);
	}

      /* Now, which type of index is it? */
      if (cpu_section > 0)
	{
	  /* Not section zero - check extended toys */
	  scratch = do_memory_read (eid_ac, 1);
	  if ((scratch & 0407777000000LL) > 0)
	    {
	      /* Global index, signed displacement */
	      if (einst_addr & 0400000)
		{
		  eaddr = (scratch & 07777777777LL) - einst_addr;
		}
	      else
		{
		  eaddr = (scratch & 07777777777LL) + einst_addr;
		}
	      goto indexdone;
	    }
	  /* Local index */
	  eaddr = (scratch & 0777777) + einst_addr;
	  /* eaddr=(scratch&0777777)+einst_addr; */
	  if (eaddr > 0777777)
	    {
	      printf ("%%EACALC: WRAPPING LOCAL INDEX RESULT\n");
	      eaddr = eaddr - 0777777;
	    }
	  goto indexdone;
	}
      /* NO EXTENDED TOYS FROM SECTION ZERO - FORCE LOCAL */

      scratch = do_memory_read (eid_ac, 0);

      eaddr = (scratch&0777777) + einst_addr;
      if (eaddr > 0777777)
	{
	  printf ("%%EACALC: LOCAL INDEX RESULT MAKES NO SENSE\n");
	  printf ("%%EACALC: eaddr %lo, scratch %lo,",eaddr,scratch);
	  printf (" eid_ac %lo, einst_addr %lo\n",eid_ac,einst_addr);

	  printf ("%%EACALC: HALTING\n");
	  eaddr=eaddr-0777777;
	  ucode_stop=3;
	  return(eaddr);
	}
      goto indexdone;
    }
/* Index is finished, or no indexing in the first place ^_^ */
indexdone:
/* Now, are we indirecting? */
  if (eid_bit == 0)
    {
      /* No.  Clean up and exit. */
      global_mode = 0;
      goto ecalc_done;
    }

  /* We're indirecting! */
  if (inst_trace == 1)
    {
      printf ("%%EACALC: INDIRECTING\n");
    }
  eaddr = ((cpu_section << 18) | eaddr);
indirect_start:

  scratch = do_memory_read (eaddr, 1);

/* Which kind of indirect? */
  if (cpu_section == 0)
    {
      data = scratch;
      goto ecalc_start;
    }
  if ((scratch & 0600000000000LL) == 0600000000000LL)
    {
      /* Oh, shit. */
      printf ("%%EACALC: PAGE FAIL TRAP IN EACALC\n");
      ucode_stop = 1;
      return (0);
    }
  /* Not section 0, and valid indirect word. */
  if ((scratch & 0600000000000LL) == 0400000000000LL)
    {
      /* Local indirect. */
      data = scratch;
      goto ecalc_start;
    }
  else
    {
      /* Global indirect. */
      /* Index on the indirect? */
      if ((scratch & 0170000000000LL) > 0)
	{
	  /* Yes. */
	  eaddr = (do_memory_read (((scratch & 0170000000000LL) >> 30), 1) & 0007777777777LL) + (scratch & 07777777777LL);
	  /* Chou Very Bad! ^_^ */
	  global_mode = 1;
	  goto indirect_done;
	}
      else
	{
	  eaddr = (scratch & 07777777777LL);
	  global_mode = 1;
	  goto indirect_done;
	}
    }
indirect_done:
  if ((scratch & 0200000000000LL) == 0200000000000LL)
    {
      /* Again! */
      goto indirect_start;
    }

ecalc_done:
  /* Done! */
  if (global_mode == 0)
    {
      eaddr = (cpu_section << 18) | (eaddr & 0777777LL);
    }
  return (eaddr);
}

unsigned long long 
apr_blko ()
{

/* Put a word in E describing the processor. */
  br = 0;
  br = br | 02;			/* EXTENDED ADDRESS */
  br = br << 18;
  br = br | UCODE_VERSION;	/* VERSION NUMBER */
  br = br << 6;
  br = br | 004;		/* EXTENDED KL10, 60HZ,
				   NO CHANNELS, NO CACHE, NO MASTER
				   OSC */
  br = br << 12;
  br = br | SERIALNUMBER;	/* SERIAL NUMBER */
  do_memory_write (e_addr, br);	/* Store */

  return (0);
}

void 
cons_set_tty_noecho ()
{

  tcgetattr (termfile, &termios_p);
  termios_p.c_lflag &= ~(ECHO);
  tcsetattr (termfile, TCSANOW, &termios_p);

}

void 
cons_set_tty_echo ()
{

  tcgetattr (termfile, &termios_p);
  termios_p.c_lflag |= ECHO;
  tcsetattr (termfile, TCSANOW, &termios_p);

}

unsigned long 
parse_byte_pointer (unsigned long long data)
{

/* Build the bptr_* variables */
  bptr_type = 0;		/* UNTIL EXTENDED ADDRESSING IS DONE */
  bptr_pos = (data & 0770000000000LL) >> 30;
  bptr_size = (data & 0007700000000LL) >> 24;
  bptr_addr = calc_e_addr (data & 077777777LL);
  bptr_ac = (data & 017000000LL) >> 18;
  bptr_loc = (data & 0777777LL);
  bptr_ind = (data & 020000000LL) >> 22;

  return (0);
}

unsigned long long 
build_byte_pointer ()
{
/* Build a byte pointer */

  unsigned long long ll_buffer;
  ll_buffer = 0;

  if (bptr_type > 0)
    {
      printf ("%%CPU: BIG BYTE POINTERS NOT DONE YET\n");
    }

  ll_buffer = bptr_loc;
  ll_buffer = ll_buffer | (bptr_ac << 18);
  ll_buffer = ll_buffer | (bptr_ind << 22);
  ll_buffer = ll_buffer | (bptr_size << 24);
  ll_buffer = ll_buffer | (bptr_pos << 30);

  return (ll_buffer);
}
