#include <stdio.h>
#include "math.h"

unsigned long long arx,pc;

unsigned long get_lf_half (unsigned long long data)
{

  unsigned long scratch;
  scratch = ((data >> 18) & 0777777);
  return (scratch);

}

unsigned long get_rt_half (unsigned long long data)
{
  return (data & 0777777);
}

unsigned long long form_word (unsigned long data_lf, unsigned long data_rt)
{

  unsigned long long scratch;
  scratch = data_lf;
  scratch = scratch << 18;
  scratch = scratch | data_rt;
  return (scratch);

}

unsigned long long do_new_div(unsigned long long data1, unsigned long long data2);

int main(){
  
  unsigned long long product;
  unsigned long prod_lf,prod_rt;
  
  product=do_new_div(02LL,06LL);
  
  prod_lf=(product&0777777000000LL)>>18;
  prod_rt=(product&0777777LL);
  
  printf("divtest: %lo,,%lo\n",prod_lf,prod_rt);
  
  return(0);
}

unsigned long long do_new_div(unsigned long long data1, unsigned long long data2){

  /* I need 3 registers */
  unsigned long long divisor = data2;
  unsigned long long dividend = data1;

  /* long double remainder = 0; */
  unsigned long long remainder_lf = dividend,remainder_rt = 0;

  /* Remainder needs to be 72 bits (36+36) */
  int reps = 0,carry = 0;

  /* Shift remainder right one */
    remainder_rt=remainder_rt>>1;
    remainder_rt=remainder_rt|((remainder_lf&01LL)<<36);
    remainder_lf=remainder_lf>>1;

  /* Now start */
  while(reps <= 36){
    printf("DIVLOOP: remainder_lf = %lo,,%lo remainder_rt=%lo,,%lo\n",(unsigned long)(remainder_lf>>18)&0777777,(unsigned long)remainder_lf&0777777,(unsigned long)(remainder_rt>>18)&0777777,(unsigned long)remainder_rt&0777777);

    /* Subtract the Divisor register from the left half of the
       Remainder register, and place the result in the left half
       of the Remainder register */

    /* remainder_lf=remainder_lf-divisor; */

    remainder_lf=do_sub(remainder_lf,divisor);

    /* Test the remainder */
    if((remainder_lf&0400000000000LL)==0400000000000LL){
      /* Negative */
      printf("Check: Negative result\n");
      /* Restore the original value of remainder */
      remainder_lf=do_add(remainder_lf,divisor);
      /* Shift Remainder to the left, setting rightmost bit to 0 */
      remainder_rt=remainder_rt<<1;
      remainder_lf=remainder_lf|((remainder_rt&01000000000000LL)>>36);
      remainder_lf=remainder_lf<<1;
      remainder_rt=remainder_rt&0777777777776LL;
    }else{
      /* Positive - Shift remainder to the left, setting leftmost bit
	 to 1 */
      remainder_rt=remainder_rt<<1;
      remainder_lf=remainder_lf|((remainder_rt&01000000000000LL)>>36);
      remainder_lf=remainder_lf<<1;
      remainder_lf=remainder_lf|0400000000000LL;
    }
    reps++;
  }
  /* 36th rep */
  /* Shift left half of remainder right one bit */
  remainder_lf=remainder_lf>>1;

return(remainder_lf);
}

