/* $Header: /CVS/ka10/flags.h,v 1.2 1998/10/06 03:48:15 mcl Exp $ */

/* Mirian Crzig Lennox <mcl@cosmic.com> started this file. */

/* Add your name and email here when you make meaningful changes */
/* Then mail the changes to me so I know about them! */

/* This program is free software, you can redistribute it and/or
   modify it under the terms of the GNU Public License as published
   by the Free Software Foundation.  It is copyrighted by myself and
   all those who contribute code and annote their names above */

#ifndef _E10_FLAGS_H_
#define _E10_FLAGS_H_

/* Processor flag bit positions. */

#define F_AROV		0400000000000LL		/* arithmetic overflow */
#define F_CRY0		0200000000000LL		/* carry 0 */
#define F_CRY1		0100000000000LL		/* carry 1 */
#define F_FOV		0040000000000LL		/* floating overflow */
#define F_FPD		0020000000000LL		/* first part done */
#define F_USER		0010000000000LL		/* user mode */
#define F_IOT		0004000000000LL		/* user in-out mode */
#define F_PUBL		0002000000000LL		/* public */
#define F_AFI		0001000000000LL		/* address failure inhibit */
#define F_TRAP2		0000400000000LL		/* stack trap */
#define F_TRAP1		0000200000000LL		/* arithmetic trap */
#define F_FXU		0000100000000LL		/* floating exp. underflow */
#define F_DCK		0000040000000LL		/* divide check */
#define F_XXX		0000037000000LL		/* unused */

extern unsigned long pc_hi;		/* flags halfword */

#define FLAG_SET(x) (pc_hi |= (x))
#define FLAG_CLR(x) (pc_hi &= (~(x)))

#endif /* _E10_FLAGS_H_ */
