/* MATH.H for E10-KL10 */
/* Note that this one only interfaces to the old functions in alu.c, alu.h */

#include "alu.c"
#include "alu.h"
#include "flags.h"

extern unsigned long long arx;
extern unsigned long long pc;		/* The PC */
unsigned long pc_hi;			/* PC flags */

extern unsigned long get_rt_half(unsigned long long data);
extern unsigned long get_lf_half(unsigned long long data);
extern unsigned long long form_word(unsigned long data_lf,unsigned long data_rt);
unsigned long long new_imul(unsigned long long data1, unsigned long long data2);

unsigned long alu_lo,alu_hi,alux_lo,alux_hi;

unsigned long long do_add(unsigned long long data1, unsigned long long data2){
unsigned long long ll_buffer;


/* Screw with the flags */
pc_hi=get_lf_half(pc);

/* Return data1 + data2 */
pdp10_add(get_lf_half(data1),get_rt_half(data1),get_lf_half(data2),get_rt_half(data2));
ll_buffer=form_word(alu_lo,alu_hi);

/* Screw with the flags again. */
pc=form_word(pc_hi,get_rt_half(pc));	/* Drop right left back on */

return(ll_buffer);
}

unsigned long long do_sub(unsigned long long data1, unsigned long long data2){
unsigned long long ll_buffer;

/* Screw with the flags */
pc_hi=get_lf_half(pc);

/* Return data1 + data2 */
pdp10_sub(get_lf_half(data1),get_rt_half(data1),get_lf_half(data2),get_rt_half(data2));
ll_buffer=form_word(alu_lo,alu_hi);

/* Screw with the flags again. */
pc=form_word(pc_hi,get_rt_half(pc));	/* Drop right left back on */

return(ll_buffer);
}

unsigned long long do_imul(unsigned long long data1, unsigned long long data2){
unsigned long long ll_buffer;

/* Screw with the flags */
pc_hi=get_lf_half(pc);

/* Return data1 + data2 */
/* pdp10_imul(get_lf_half(data1),get_rt_half(data1),get_lf_half(data2),get_rt_half(data2));
   ll_buffer=form_word(alu_lo,alu_hi); */

/* Screw with the flags again. */
/* pc=form_word(pc_hi,get_rt_half(pc));	 */ /* Drop right left back on */

ll_buffer=new_imul(data1,data2);

return(ll_buffer);
}

unsigned long long do_idiv(unsigned long long data1, unsigned long long data2){
/* DIVISON IS ODD, IT CLOBBERS ARX (ARX = REMAINDER) */

unsigned long long ll_buffer = 0;
int negate_result = 0;

/* Look for stupid programmer mistakes */
/*
printf("%%CPU: DO_IDIV: 1 %lo,,%lo ; 2 %lo,,%lo\n",get_lf_half(data1),get_rt_half(data1),get_lf_half(data2),get_rt_half(data2));
*/

if((data1==0)||(data2==0)){
	/* Division by zero is impossible! */
	pc=pc|(F_TRAP1|F_AROV|F_DCK); return(0); }

/* THIS IS A CROCK! THIS IS GROSS AND UGLY, BUT IT (KINDA) WORKS! */
/* PLEASE, PLEASE IMPROVE THIS!  IT DOESN'T DEAL WITH FLAGS RIGHT! */

/* Sign check */
 if(data1&0400000000000LL){
   /* Negative */
   negate_result=1;
   data1=data1&0377777777777LL;
   data1=~data1;
   data1=data1&0377777777777LL;
   printf("CPU: IDIV: Data1 negative\n");
 }
 if(data2&0400000000000LL){
   /* Negative */
   negate_result=1;
   data2=data2&0377777777777LL;
   data2=~data2;
   data2=data2&0377777777777LL;
   printf("CPU: IDIV: Data2 negative\n");
 }

/* First, get the answer */
ll_buffer=data1/data2;

/* Now, the remainder... */

arx=data1-(ll_buffer*data2);

/* Now fix the signs */

 if(negate_result==1){
   ll_buffer=~ll_buffer;
   ll_buffer=ll_buffer&0377777777777LL;
   ll_buffer=ll_buffer|0400000000000LL;
 }

/*
printf("%%CPU: DO_IDIV: ANS %lo,,%lo ; ARX %lo,,%lo\n",get_lf_half(ll_buffer),get_rt_half(ll_buffer),get_lf_half(arx),get_rt_half(arx));
*/

return(ll_buffer);
}

unsigned long long new_imul(unsigned long long data1, unsigned long long data2){

  /* "The first rule of magic is simple.  Don't waste your time waving your
      hands and hoping when a rock or a club will do."
                    -- McCloctnik the Lucid */

unsigned long long product1,product2,product;
unsigned int pos,data2carry;

/* Do a new multiply. */
product1=0; product2=0; product=0; pos=0; data2carry=0;

/* Shift data2 to the right, watching what falls off the end. */
 multiply_loop:
pos++;
data2carry=(data2&01LL); data2=data2>>1;
 if(data2carry==1){
   product=product+data1;
 }
data1=(data1<<1);
 if(pos==37){return(product);}
goto multiply_loop;

}




