/* $Header: /CVS/ka10/op.h,v 1.7 1998/10/06 20:11:58 dseagrav Exp $ */

/* Mirian Crzig Lennox <mcl@cosmic.com> started this file. */

/* Add your name and email here when you make meaningful changes */
/* Then mail the changes to me so I know about them! */

/* This program is free software, you can redistribute it and/or
   modify it under the terms of the GNU Public License as published
   by the Free Software Foundation.  It is copyrighted by myself and
   all those who contribute code and annote their names above */

/* array of opcode strings, indexed by opcode values, below. */

char *op_str[];


/* Opcode values for PDP-10 instruction set. */

/* UUOs, extended instructions. 0-77 */

#define OP_ILLEGL	0000
#define OP_CMPSL	0001
#define OP_CMPSE	0002
#define OP_CMPSLE	0003
#define OP_EDIT		0004
#define OP_CMPSGE	0005
#define OP_CMPSN	0006
#define OP_CMPSG	0007
#define OP_CVTDBO	0010
#define OP_CVTDBT	0011
#define OP_CVTBDO	0012
#define OP_CVTBDT	0013
#define OP_MOVSO	0014
#define OP_MOVST	0015
#define OP_MOVSLJ	0016
#define OP_MOVSRJ	0017
#define OP_XBLT		0020
#define OP_GSNGL	0021
#define OP_GDBLE	0022
#define OP_GDFIX	0023
#define OP_GFIX		0024
#define OP_GDFIXR	0025
#define OP_GFIXR	0026
#define OP_DGFLTR	0027
#define OP_GFLTR	0030
#define OP_GFSC		0031
#define OP_U032		0032
#define OP_U033		0033
#define OP_U034		0034
#define OP_U035		0035
#define OP_U036		0036
#define OP_U037		0037
#define OP_CALL		0040
#define OP_INIT		0041
#define OP_U042		0042
#define OP_U043		0043
#define OP_U044		0044
#define OP_U045		0045
#define OP_U046		0046
#define OP_CALLI	0047
#define OP_OPEN		0050
#define OP_TTCALL	0051
#define OP_U052		0052
#define OP_U053		0053
#define OP_U054		0054
#define OP_RENAME	0055
#define OP_IN		0056
#define OP_OUT		0057
#define OP_SETSTS	0060
#define OP_STATO	0061
#define OP_STATUS	0062
#define OP_STATZ	0063
#define OP_INBUF	0064
#define OP_OUTBUF	0065
#define OP_INPUT	0066
#define OP_OUTPUT	0067
#define OP_CLOSE	0070
#define OP_RELEAS	0071
#define OP_MTAPE	0072
#define OP_UGETF	0073
#define OP_USETI	0074
#define OP_USETO	0075
#define OP_LOOKUP	0076
#define OP_ENTER	0077

/* more extended instructions. 100-177 */

#define OP_UJEN		0100
#define OP_U101		0101
#define OP_GFAD		0102
#define OP_GFSB		0103
#define OP_JSYS		0104
#define OP_ADJSP	0105
#define OP_GFMP		0106
#define OP_GFDV		0107
#define OP_DFAD		0110
#define OP_DFSB		0111
#define OP_DFMP		0112
#define OP_DFDV		0113
#define OP_DADD		0114
#define OP_DSUB		0115
#define OP_DMUL		0116
#define OP_DDIV		0117
#define OP_DMOVE	0120
#define OP_DMOVN	0121
#define OP_FIX		0122
#define OP_EXTEND	0123
#define OP_DMOVEM	0124
#define OP_DMOVNM	0125
#define OP_FIXR		0126
#define OP_FLTR		0127
#define OP_UFA		0130
#define OP_DFN		0131
#define OP_FSC		0132
#define OP_IBP		0133
#define OP_ILDB		0134
#define OP_LDB		0135
#define OP_IDPB		0136
#define OP_DPB		0137
#define OP_FAD		0140
#define OP_FADL		0141
#define OP_FADM		0142
#define OP_FADB		0143
#define OP_FADR		0144
#define OP_FADRI	0145
#define OP_FADRM	0146
#define OP_FADRB	0147
#define OP_FSB		0150
#define OP_FSBL		0151
#define OP_FSBM		0152
#define OP_FSBB		0153
#define OP_FSBR		0154
#define OP_FSBRI	0155
#define OP_FSBRM	0156
#define OP_FSBRB	0157
#define OP_FMP		0160
#define OP_FMPL		0161
#define OP_FMPM		0162
#define OP_FMPB		0163
#define OP_FMPR		0164
#define OP_FMPRI	0165
#define OP_FMPRM	0166
#define OP_FMPRB	0167
#define OP_FDV		0170
#define OP_FDVL		0171
#define OP_FDVM		0172
#define OP_FDVB		0173
#define OP_FDVR		0174
#define OP_FDVRI	0175
#define OP_FDVRM	0176
#define OP_FDVRB	0177

/* Movement and Arithmetic instructions. 200-277 */

#define OP_MOVE		0200
#define OP_MOVEI	0201
#define OP_MOVEM	0202
#define OP_MOVES	0203
#define OP_MOVS		0204
#define OP_MOVSI	0205
#define OP_MOVSM	0206
#define OP_MOVSS	0207
#define OP_MOVN		0210
#define OP_MOVNI	0211
#define OP_MOVNM	0212
#define OP_MOVNS	0213
#define OP_MOVM		0214
#define OP_MOVMI	0215
#define OP_MOVMM	0216
#define OP_MOVMS	0217
#define OP_IMUL		0220
#define OP_IMULI	0221
#define OP_IMULM	0222
#define OP_IMULB	0223
#define OP_MUL		0224
#define OP_MULI		0225
#define OP_MULM		0226
#define OP_MULB		0227
#define OP_IDIV		0230
#define OP_IDIVI	0231
#define OP_IDIVM	0232
#define OP_IDIVB	0233
#define OP_DIV		0234
#define OP_DIVI		0235
#define OP_DIVM		0236
#define OP_DIVB		0237
#define OP_ASH		0240
#define OP_ROT		0241
#define OP_LSH		0242
#define OP_JFFO		0243
#define OP_ASHC		0244
#define OP_ROTC		0245
#define OP_LSHC		0246
#define OP_U247		0247
#define OP_EXCH		0250
#define OP_BLT		0251
#define OP_AOBJP	0252
#define OP_AOBJN	0253
#define OP_JRST		0254
#define OP_JFCL		0255
#define OP_XCT		0256
#define OP_MAP		0257
#define OP_PUSHJ	0260
#define OP_PUSH		0261
#define OP_POP		0262
#define OP_POPJ		0263
#define OP_JSR		0264
#define OP_JSP		0265
#define OP_JSA		0266
#define OP_JRA		0267
#define OP_ADD		0270
#define OP_ADDI		0271
#define OP_ADDM		0272
#define OP_ADDB		0273
#define OP_SUB		0274
#define OP_SUBI		0275
#define OP_SUBM		0276
#define OP_SUBB		0277

/* Conditional instructions. 300-377 */

#define OP_CAI		0300
#define OP_CAIL		0301
#define OP_CAIE		0302
#define OP_CAILE	0303
#define OP_CAIA		0304
#define OP_CAIGE	0305
#define OP_CAIN		0306
#define OP_CAIG		0307
#define OP_CAM		0310
#define OP_CAML		0311
#define OP_CAME		0312
#define OP_CAMLE	0313
#define OP_CAMA		0314
#define OP_CAMGE	0315
#define OP_CAMN		0316
#define OP_CAMG		0317
#define OP_JUMP		0320
#define OP_JUMPL	0321
#define OP_JUMPE	0322
#define OP_JUMPLE	0323
#define OP_JUMPA	0324
#define OP_JUMPGE	0325
#define OP_JUMPN	0326
#define OP_JUMPG	0327
#define OP_SKIP		0330
#define OP_SKIPL	0331
#define OP_SKIPE	0332
#define OP_SKIPLE	0333
#define OP_SKIPA	0334
#define OP_SKIPGE	0335
#define OP_SKIPN	0336
#define OP_SKIPG	0337
#define OP_AOJ		0340
#define OP_AOJL		0341
#define OP_AOJE		0342
#define OP_AOJLE	0343
#define OP_AOJA		0344
#define OP_AOJGE	0345
#define OP_AOJN		0346
#define OP_AOJG		0347
#define OP_AOS		0350
#define OP_AOSL		0351
#define OP_AOSE		0352
#define OP_AOSLE	0353
#define OP_AOSA		0354
#define OP_AOSGE	0355
#define OP_AOSN		0356
#define OP_AOSG		0357
#define OP_SOJ		0360
#define OP_SOJL		0361
#define OP_SOJE		0362
#define OP_SOJLE	0363
#define OP_SOJA		0364
#define OP_SOJGE	0365
#define OP_SOJN		0366
#define OP_SOJG		0367
#define OP_SOS		0370
#define OP_SOSL		0371
#define OP_SOSE		0372
#define OP_SOSLE	0373
#define OP_SOSA		0374
#define OP_SOSGE	0375
#define OP_SOSN		0376
#define OP_SOSG		0377


/* Bit instructions. 400-477 */

#define OP_SETZ		0400
#define OP_SETZI	0401
#define OP_SETZM	0402
#define OP_SETZB	0403
#define OP_AND		0404
#define OP_ANDI		0405
#define OP_ANDM		0406
#define OP_ANDB		0407
#define OP_ANDCA	0410
#define OP_ANDCAI	0411
#define OP_ANDCAM	0412
#define OP_ANDCAB	0413
#define OP_SETM		0414
#define OP_SETMI	0415
#define OP_SETMM	0416
#define OP_SETMB	0417
#define OP_ANDCM	0420
#define OP_ANDCMI	0421
#define OP_ANDCMM	0422
#define OP_ANDCMB	0423
#define OP_SETA		0424
#define OP_SETAI	0425
#define OP_SETAM	0426
#define OP_SETAB	0427
#define OP_XOR		0430
#define OP_XORI		0431
#define OP_XORM		0432
#define OP_XORB		0433
#define OP_OR		0434
#define OP_ORI		0435
#define OP_ORM		0436
#define OP_ORB		0437
#define OP_ANDCB	0440
#define OP_ANDCBI	0441
#define OP_ANDCBM	0442
#define OP_ANDCBB	0443
#define OP_EQV		0444
#define OP_EQVI		0445
#define OP_EQVM		0446
#define OP_EQVB		0447
#define OP_SETCA	0450
#define OP_SETCAI	0451
#define OP_SETCAM	0452
#define OP_SETCAB	0453
#define OP_ORCA		0454
#define OP_ORCAI	0455
#define OP_ORCAM	0456
#define OP_ORCAB	0457
#define OP_SETCM	0460
#define OP_SETCMI	0461
#define OP_SETCMM	0462
#define OP_SETCMB	0463
#define OP_ORCM		0464
#define OP_ORCMI	0465
#define OP_ORCMM	0466
#define OP_ORCMB	0467
#define OP_ORCB		0470
#define OP_ORCBI	0471
#define OP_ORCBM	0472
#define OP_ORCBB	0473
#define OP_SETO		0474
#define OP_SETOI	0475
#define OP_SETOM	0476
#define OP_SETOB	0477

/* Halfword instructions. 500-577 */

#define OP_HLL		0500
#define OP_HLLI		0501
#define OP_HLLM		0502
#define OP_HLLS		0503
#define OP_HRL		0504
#define OP_HRLI		0505
#define OP_HRLM		0506
#define OP_HRLS		0507
#define OP_HLLZ		0510
#define OP_HLLZI	0511
#define OP_HLLZM	0512
#define OP_HLLZS	0513
#define OP_HRLZ		0514
#define OP_HRLZI	0515
#define OP_HRLZM	0516
#define OP_HRLZS	0517
#define OP_HLLO		0520
#define OP_HLLOI	0521
#define OP_HLLOM	0522
#define OP_HLLOS	0523
#define OP_HRLO		0524
#define OP_HRLOI	0525
#define OP_HRLOM	0526
#define OP_HRLOS	0527
#define OP_HLLE		0530
#define OP_HLLEI	0531
#define OP_HLLEM	0532
#define OP_HLLES	0533
#define OP_HRLE		0534
#define OP_HRLEI	0535
#define OP_HRLEM	0536
#define OP_HRLES	0537
#define OP_HRR		0540
#define OP_HRRI		0541
#define OP_HRRM		0542
#define OP_HRRS		0543
#define OP_HLR		0544
#define OP_HLRI		0545
#define OP_HLRM		0546
#define OP_HLRS		0547
#define OP_HRRZ		0550
#define OP_HRRZI	0551
#define OP_HRRZM	0552
#define OP_HRRZS	0553
#define OP_HLRZ		0554
#define OP_HLRZI	0555
#define OP_HLRZM	0556
#define OP_HLRZS	0557
#define OP_HRRO		0560
#define OP_HRROI	0561
#define OP_HRROM	0562
#define OP_HRROS	0563
#define OP_HLRO		0564
#define OP_HLROI	0565
#define OP_HLROM	0566
#define OP_HLROS	0567
#define OP_HRRE		0570
#define OP_HRREI	0571
#define OP_HRREM	0572
#define OP_HRRES	0573
#define OP_HLRE		0574
#define OP_HLREI	0575
#define OP_HLREM	0576
#define OP_HLRES	0577

/* Test instructions. 600-677 */

#define OP_TRN		0600
#define OP_TLN		0601
#define OP_TRNE		0602
#define OP_TLNE		0603
#define OP_TRNA		0604
#define OP_TLNA		0605
#define OP_TRNN		0606
#define OP_TLNN		0607
#define OP_TDN		0610
#define OP_TSN		0611
#define OP_TDNE		0612
#define OP_TSNE		0613
#define OP_TDNA		0614
#define OP_TSNA		0615
#define OP_TDNN		0616
#define OP_TSNN		0617
#define OP_TRZ		0620
#define OP_TLZ		0621
#define OP_TRZE		0622
#define OP_TLZE		0623
#define OP_TRZA		0624
#define OP_TLZA		0625
#define OP_TRZN		0626
#define OP_TLZN		0627
#define OP_TDZ		0630
#define OP_TSZ		0631
#define OP_TDZE		0632
#define OP_TSZE		0633
#define OP_TDZA		0634
#define OP_TSZA		0635
#define OP_TDZN		0636
#define OP_TSZN		0637
#define OP_TRC		0640
#define OP_TLC		0641
#define OP_TRCE		0642
#define OP_TLCE		0643
#define OP_TRCA		0644
#define OP_TLCA		0645
#define OP_TRCN		0646
#define OP_TLCN		0647
#define OP_TDC		0650
#define OP_TSC		0651
#define OP_TDCE		0652
#define OP_TSCE		0653
#define OP_TDCA		0654
#define OP_TSCA		0655
#define OP_TDCN		0656
#define OP_TSCN		0657
#define OP_TRO		0660
#define OP_TLO		0661
#define OP_TROE		0662
#define OP_TLOE		0663
#define OP_TROA		0664
#define OP_TLOA		0665
#define OP_TRON		0666
#define OP_TLON		0667
#define OP_TDO		0670
#define OP_TSO		0671
#define OP_TDOE		0672
#define OP_TSOE		0673
#define OP_TDOA		0674
#define OP_TSOA		0675
#define OP_TDON		0676
#define OP_TSON		0677


/* IO instructions. 700-777 */
/* These are mostly placeholders for now. */

#define OP_IO700	0700
#define OP_IO701	0701
#define OP_IO702	0702
#define OP_IO703	0703
#define OP_IO704	0704
#define OP_IO705	0705
#define OP_IO706	0706
#define OP_IO707	0707
#define OP_IO710	0710
#define OP_IO711	0711
#define OP_IO712	0712
#define OP_IO713	0713
#define OP_IO714	0714
#define OP_IO715	0715
#define OP_IO716	0716
#define OP_IO717	0717
#define OP_IO720	0720
#define OP_IO721	0721
#define OP_IO722	0722
#define OP_IO723	0723
#define OP_IO724	0724
#define OP_IO725	0725
#define OP_IO726	0726
#define OP_IO727	0727
#define OP_IO730	0730
#define OP_IO731	0731
#define OP_IO732	0732
#define OP_IO733	0733
#define OP_IO734	0734
#define OP_IO735	0735
#define OP_IO736	0736
#define OP_IO737	0737
#define OP_IO740	0740
#define OP_IO741	0741
#define OP_IO742	0742
#define OP_IO743	0743
#define OP_IO744	0744
#define OP_IO745	0745
#define OP_IO746	0746
#define OP_IO747	0747
#define OP_IO750	0750
#define OP_IO751	0751
#define OP_IO752	0752
#define OP_IO753	0753
#define OP_IO754	0754
#define OP_IO755	0755
#define OP_IO756	0756
#define OP_IO757	0757
#define OP_IO760	0760
#define OP_IO761	0761
#define OP_IO762	0762
#define OP_IO763	0763
#define OP_IO764	0764
#define OP_IO765	0765
#define OP_IO766	0766
#define OP_IO767	0767
#define OP_IO770	0770
#define OP_IO771	0771
#define OP_IO772	0772
#define OP_IO773	0773
#define OP_IO774	0774
#define OP_IO775	0775
#define OP_IO776	0776
#define OP_IO777	0777
