/* E10-KL10 TOPS-10 PAGER */

/* VARIABLES */

int pg_pager_active;				/* PAGER ACTIVE bit */
unsigned long pg_upt_page,pg_ept_page;		/* Lcns for proc tables */
unsigned long pg_pc_fm_block,pg_pc_section;	/* Previous context stuff */
unsigned long long pg_pagetable[8192];		/* Page table */
int pg_cache_strategy;				/* Cache strategy */
unsigned long long pg_scratch;			/* Scratch word */
int pg_fm_block;				/* FM block select */
int pg_no_update;				/* No acct. update flag */


/* FUNCTIONS */

unsigned long long cono_pag();
unsigned long long coni_pag();
unsigned long long datao_pag();
unsigned long long datai_pag();
unsigned long long blko_pag();
unsigned long pg_get_pma(unsigned long address);

/* CODE */

unsigned long long cono_pag(){

	pg_cache_strategy=((e_addr&0600000)>>16);
	if(e_addr&0040000){
		/* TOPS-20 PAGING SELECT */
		printf("%%PAGER: TOPS-20 PAGING NOT AVAILABLE\n");
		}
	else{
		/* TOPS-10 PAGING SELECT */
		}
	if(e_addr&0020000){
		/* PAGER ENABLE */
		printf("%%PAGER: PAGING ENABLED\n");
		pg_pager_active=1;
		}
	else{
		/* PAGER DISABLE */
		printf("%%PAGER: PAGING DISABLED\n");
		pg_pager_active=0;
		}
	pg_ept_page=e_addr&017777;

return(0);
}

unsigned long long coni_pag(){
pg_scratch=0;
pg_scratch=pg_scratch|pg_cache_strategy;
pg_scratch=pg_scratch<<16;
if(pg_pager_active){ pg_scratch=pg_scratch|0020000; }
pg_scratch=pg_scratch|pg_ept_page;
do_memory_write(e_addr,pg_scratch);

return(pg_scratch);
}

unsigned long long datao_pag(){
/* This invalidates the entire page table. */

pg_scratch=do_memory_read(e_addr,0);
if(pg_scratch&0400000000000LL){
	/* SELECT AC BLOCKS */
	pg_fm_block=(pg_scratch&0007000000000LL)>>27;
	pg_pc_fm_block=(pg_scratch&0000700000000LL)>>25;
	}
if(pg_scratch&0200000000000LL){
	/* SELECT PREVIOUS CONTEXT SECTION */
	pg_pc_section=(pg_scratch&0000037000000LL)>>18;
	}
if(pg_scratch&0100000000000LL){
	/* LOAD USER BASE ADDRESS */
	pg_upt_page=pg_scratch&017777;
	}
if(pg_scratch&0400000LL){ pg_no_update=1; }else{ pg_no_update=0; }

return(0);
}

unsigned long long datai_pag(){
pg_scratch=0;

pg_scratch=pg_fm_block;
pg_scratch=pg_scratch<<3;
pg_scratch=pg_scratch|pg_pc_fm_block;
pg_scratch=pg_scratch<<6;
pg_scratch=pg_scratch|pg_pc_section;
pg_scratch=pg_scratch<<1;
pg_scratch=pg_scratch|pg_no_update;
pg_scratch=pg_scratch<<17;
pg_scratch=pg_scratch|pg_upt_page;

do_memory_write(e_addr,pg_scratch);

return(0);
}

unsigned long long blko_pag(){
/* CLRPT - Invalidate the page table line (8 entries) containing the mapping
   for the page refrenced by e_addr. */
printf("%%PAGER: CLRPT NOT IMPLEMENTED YET\n");

return(0);
}

unsigned long pg_get_pma(unsigned long address){
printf("%%PAGER: THIS IS NOT DONE!\n");

/* Convert address to a physical address. */

/* TOPS-10 PAGING PROCEDURE:

*/

return(address);
}
